.MODULE                                     mod_agCalcNewFreq;


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "ag0.h"

#define     ALLOWEDDISCHORDDIST_DIV2    10

.VAR/DM     tempVoiceNum;
.VAR/DM     tempNewStep;
.VAR/DM     tempBaseFreq;
.VAR/DM     tempNewFreq;
.VAR/DM     tempDischordScalar;
.VAR/DM     tempWantedDischord;
.VAR/DM     tempActualDischord;
.VAR/DM     tempNewDischord0;
.VAR/DM     tempNewDischord1;
.VAR/DM     tempTempDischord;
.VAR/DM     tempTempFreq;

.VAR/DM     localNewFreq;
.VAR/DM     localVoiceNum;
.VAR/DM     localActualDischord;

.VAR/DM     a_MIDIDistDischord[OCT*2+1];
.INIT       a_MIDIDistDischord:             0, 100, 70, 50, 20,
                                            30, 80, 10, 90, 40,
                                            60, 110, 0, 100, 70,
                                            50, 20, 30, 80, 10,
                                            90, 40, 60, 110, 0;


#define GETAGPARAM(param, reg) \
    I2 = ^param; \
    modify(I2, M2); \
    reg = DM(I2, M0)

.ENTRY      agCalcNewFreq;

agCalcNewFreq:
    DM(tempVoiceNum) = AR;
    M2 = AR;
    
    GETAGPARAM(a_agLastNotes, AR);
    DM(tempBaseFreq) = AR;
        
    AR = DM(I6, M7);
    GETAGPARAM(a_agRandomness, MY0);
    MR = AR * MY0 (SU);
    
    AY0 = DM(tempBaseFreq);
    AR = MR1 + AY0;
    DM(tempNewFreq) = AR;
    
    /* check if new freq is too big/small */
    GETAGPARAM(a_agMedFreq, AX0);
    GETAGPARAM(a_agFreqRange, AY0);

NewFreqHighCheck:
    AF = AX0 + AY0;    
    NONE = AR - AF;
    if GT AR = pass AF;

NewFreqLowCheck:
    AF = AX0 - AY0;
    NONE = AR - AF;
    if LT AR = pass AF;

    DM(tempNewFreq) = AR;
    
CalcWantedDischord:
    AF = pass 0;
    AX1 = MELODICTRACKS;
    DM(tempWantedDischord) = M0;
    DM(tempDischordScalar) = M0;
    
StartAccDischordLoop:
    AX0 = DM(tempVoiceNum);
    NONE = AX0 - AF;
    if EQ jump EndAccDischordLoop;
    
    AR = pass AF;
    M3 = AR;
    AR = DM(tempWantedDischord);
    I3 = ^a_agDischordancy;
    modify(I3, M3);
    AY0 = DM(I3, M0);
    AR = AR + AY0;
    DM(tempWantedDischord) = AR;
    AR = DM(tempDischordScalar);
    AR = AR + 1;
    DM(tempDischordScalar) = AR;
    
EndAccDischordLoop:
    AF = AF + 1;
    NONE = AX1 - AF;
    if LE jump ExitAccDischordLoop;
    jump StartAccDischordLoop;

ExitAccDischordLoop:
    AR = DM(tempDischordScalar);
    AR = pass AR;
    if EQ AR = pass 1;
    DM(tempDischordScalar) = AR;

    DM(tempActualDischord) = M0;
    
    AR = DM(tempNewFreq);
    AX0 = DM(tempVoiceNum);
    call localGetNewDischord;

    DM(tempActualDischord) = AR;

    AR = MELODICTRACKS;
    AR = AR - 1;
    if NE jump MultipleTracks;

SingleTrack:
    I2 = ^a_agLastNotes;
    modify(I2, M2);
    AR = DM(tempNewFreq);
    DM(I2, M0) = AR;
    rts;

MultipleTracks:
    MX0 = DM(tempDischordScalar);
    MY0 = ALLOWEDDISCHORDDIST_DIV2;
    MR = MX0 * MY0 (UU);
    AX0 = DM(tempActualDischord);
    AY0 = DM(tempWantedDischord);
    AR = AX0 - AY0;
    AF = abs AR;
    NONE = MR0 - AF;
    if GE jump MultiTrackOK;

    /* get dischord for NewFreq+1 */
    AR = DM(tempNewFreq);
    AR = AR + 1;
    AX0 = DM(tempVoiceNum);
    call localGetNewDischord;
    DM(tempNewDischord0) = AR;    
    
    /* get dischord for NewFreq-1 */
    AR = DM(tempNewFreq);
    AR = AR - 1;
    AX0 = DM(tempVoiceNum);
    call localGetNewDischord;
    DM(tempNewDischord1) = AR;    

    /* load originally calculated Dischord/Freq values into tempTemp mem */
    AR = DM(tempActualDischord);
    DM(tempTempDischord) = AR;
    AR = DM(tempNewFreq);
    DM(tempTempFreq) = AR;
    
    AX0 = DM(tempNewDischord0);
    AY0 = DM(tempWantedDischord);
    AR = AX0 - AY0;
    AR = abs AR;
    AY1 = AR;
    !AX1 = DM(tempActualDischord);
    AX1 = DM(tempTempDischord);
    AR = AX1 - AY0;
    AR = abs AR;
    NONE = AR - AY1;
    if LT jump DiscordTest1;

Dischord0Better:    
    DM(tempTempDischord) = AX0;
    AR = DM(tempNewFreq);
    AR = AR + 1;
    DM(tempTempFreq) = AR;

DiscordTest1:    
    AX0 = DM(tempNewDischord1);
    AY0 = DM(tempWantedDischord);
    AR = AX0 - AY0;
    AR = abs AR;
    AY1 = AR;
    !AX1 = DM(tempActualDischord);
    AX1 = DM(tempTempDischord);
    AR = AX1 - AY0;
    AR = abs AR;
    NONE = AR - AY1;
    if LT jump WriteNewFreq;

Dischord1Better:    
    DM(tempTempDischord) = AX0;
    AR = DM(tempNewFreq);
    AR = AR - 1;
    DM(tempTempFreq) = AR;

WriteNewFreq:
    I2 = ^a_agLastNotes;
    modify(I2, M2);
    AR = DM(tempTempFreq);
    DM(I2, M0) = AR;
    rts;            

MultiTrackOK:
    I2 = ^a_agLastNotes;
    modify(I2, M2);
    AR = DM(tempNewFreq);
    DM(I2, M0) = AR;
    rts;    

/*----------------------------------------------------------------------------*/

/*******************************************************************************
*
*  localGetNewDischord:
*
*    AR:   new frequency
*    AX0:  voice num being processed
*
*    calculate total dischord with other notes if currently picked note (passed
*    in AR) is chosen.
*
*******************************************************************************/

localGetNewDischord:
    DM(localNewFreq) = AR;
    DM(localVoiceNum) = AX0;
    DM(localActualDischord) = M0;
    
    AF = pass 0;
    
StartGetNewDischord:
    AX1 = DM(localNewFreq);
    AX0 = DM(localVoiceNum);
    NONE = AX0 - AF;
    if EQ jump EndGetNewDischord;
    
    !GETAGPARAM(a_agLastNotes, AY0);
    AR = pass AF;
    M3 = AR;
    I3 = ^a_agLastNotes;
    modify(I3, M3);
    AY0 = DM(I3, M0);

BringWithinOCT:    
    AR = AX1 - AY0;
    AR = abs AR;
    AY1 = OCT;
    NONE = AR - AY1;
    if LE jump AccActualDischord;
    
    NONE = AX1 - AY0;
    if LT jump IncFreqTemp;

DecFreqTemp:
    AR = AX1 - AY1;
    AX1 = AR;
    jump BringWithinOCT;

IncFreqTemp:
    AR = AX1 + AY1;
    AX1 = AR;
    jump BringWithinOCT;    

AccActualDischord:
    AR = AX1 - AY0;
    AR = AR + AY1;
    M3 = AR;
    I3 = ^a_MIDIDistDischord;
    modify(I3, M3);
    AY0 = DM(I3, M0);
    AR = DM(localActualDischord);
    AR = AR + AY0;
    DM(localActualDischord) = AR;

EndGetNewDischord:
    AF = AF + 1;
    AX1 = MELODICTRACKS;
    NONE = AX1 - AF;
    if LE jump SetGNDReturnVal;
    jump StartGetNewDischord;    

SetGNDReturnVal:
    AR = DM(localActualDischord);
    rts;    

.ENDMOD;    