.MODULE/abs=0 moddivtest;

/*
 *  initialization procedures
 *  ag_nextfreq
 *  ag_abstractize
 */

#define     MELODICTRACKS           2

.VAR/DM         v_MSWSeed;
.GLOBAL         v_MSWSeed;

.VAR/DM         v_LSWSeed;
.GLOBAL         v_LSWSeed;

.VAR/DM         a_agMedFreq[MELODICTRACKS];
.GLOBAL         a_agMedFreq;
                
.VAR/DM         a_agFreqRange[MELODICTRACKS];
.GLOBAL         a_agFreqRange;
                
.VAR/DM         a_agRandomness[MELODICTRACKS];
.GLOBAL         a_agRandomness;
                
.VAR/DM         a_agDischordancy[MELODICTRACKS];
.GLOBAL         a_agDischordancy;
                
.VAR/DM         a_agLastNotes[MELODICTRACKS];
.GLOBAL         a_agLastNotes;

.VAR/DM/CIRC    a_RandLUT[511];

.external       NoiseGen;
.external       agCalcNewFreq;

main:
    L0 = 0;  L1 = 0;  L2 = 0;  L3 = 0;
    L4 = 0;  L5 = 0;  L6 = 0;  L7 = 0;
    
    M0 = 0;
    M1 = 1;

    M6 = 0;
    M7 = 1;

    /* ALU saturation, go mode, fractional multiplies */
    ena AR_SAT;
    ena G_MODE;
    
    AR = 0x1234;
    DM(v_MSWSeed) = AR;
    AR = 0x5678;
    DM(v_LSWSeed) = AR;
    
    I6 = ^a_RandLUT;
    L6 = %a_RandLUT;
    
    CNTR = %a_RandLUT;
    
    do FRL1 until CE;
      call NoiseGen;
FRL1: DM(I6, M7) = SR0;
    
    AR = 24;
    DM(a_agMedFreq+0) = AR;
    DM(a_agLastNotes+0) = AR;
    AR = 36;
    DM(a_agMedFreq+1) = AR;
    DM(a_agLastNotes+1) = AR;
    
    AR = 12;
    DM(a_agFreqRange+0) = AR;
    AR = 6;
    DM(a_agFreqRange+1) = AR;
    
    AR = 5;
    DM(a_agRandomness+0) = AR;
    AR = 3;
    DM(a_agRandomness+1) = AR;
    
    AR = 50;
    DM(a_agDischordancy+0) = AR;
    AR = 20;
    DM(a_agDischordancy+1) = AR;

w:
    AR = 0;
    call agCalcNewFreq;
    AR = 1;
    call agCalcNewFreq;
    jump w;
    

.ENDMOD;
