/*******************************************************************************
*
*  CodecInit.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*******************************************************************************/

.module/RAM                                 modCodecInit;

#include ".\chicsys\hdr\codechdr.h"
#include ".\gen_fx\hdr\GenFX.h"
#include ".\chicsys\hdr\chicsym.h"
#include ".\comsys\hdr\comsym.h"

.ENTRY      InitAD1885;

InitAD1885:

/*
 *  nb!  reset and warmup codec code was here, but we can't do this
 *       due to different h/w config.  cycle times were:
 *
 *			reset:   34
 *			warmup:  7000
 *
 *		 we could put some delay loop here, but can't reset, unless
 *       it can be done by writing a control word to codec
 */

Enable_SPORT0_Transfers:
    ar = dm(SYSTEM_CONTROL);
    ar = setbit SPORT0_ENABLE of ar;
    dm(SYSTEM_CONTROL) = ar;
    IMASK = SPORT0TX_IRQ;
   
    /* Prime the transmit reg to kick off tx autobuffering */
    ax0 = dm(i1, m1);                    
    tx0 = ax0;

/*
 *  wait for bit15 of TAG_PHASE slot to go high.  indicates codec ready to
 *  receive comamnds from DSP.
 */

Wait_Codec_Ready:           
    ax0 = DM(rxBuf + TAG_PHASE);
    ay0 = 0x8000;           
    af = ax0 AND ay0;       
    if EQ jump Wait_Codec_Ready;
            
    idle;
    idle;        

    /* stop transmitting data to codec */
    dm(txBuf+TAG_PHASE)=M0;  
    dm(txBuf+COMMAND_ADDRESS_SLOT) = M0;
    dm(txBuf+COMMAND_DATA_SLOT) = M0;
    
    idle;
    idle;

Initialize_1885_Registers:
    I4 = ^InitCodecRegisters;
    L4 = 0;
    
    ar = ENABLE_VFbit_SLOT1_SLOT2;
    
    CNTR = 19;
    do CI until CE;
      dm(txBuf + TAG_PHASE) = ar;
      si = dm(I4, M7);
      dm(txBuf + COMMAND_ADDRESS_SLOT) = si;
      si = dm(I4, M7);
      dm(txBuf + COMMAND_DATA_SLOT) = si;
      idle;
      nop;                                  /* keep nops at end of loop! */ 
CI:   nop;
     
    DM(txBuf+TAG_PHASE) = M0;
    idle;

    IFC = 0xff;                             /* Clear pending interupts */
    nop;
   
    DM(CodecInitialized) = M1;
    DM(v_AllMute) = M1;
    
    rts;
     
.endmod;
