/******************************************************************************
*
*  NoiseGen.dsp
*
*  (c) 2002-2004 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modNoiseGen;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  external variables
 */

.EXTERNAL   v_MSWSeed;
.EXTERNAL   v_LSWSeed;

.ENTRY      NoiseGen;

NoiseGen:
    SR1 = DM(v_MSWSeed);                    /* get MSW of seed */
    SR0 = DM(v_LSWSeed);                    /* get LSW of seed */
    MY1 = 25;                               /* MSW of a */
    MY0 = 26125;                            /* LSW of a */
    MR = SR0 * MY1 (UU);                    /* a(hi)*x(lo) */
    MR = MR + SR1 * MY0 (UU);               /* a(h)*x(l)+a(l)*x(h) */
    SI = MR1;
    MR1 = MR0;
    MR2 = SI;
    MR0 = 0xfffe;                           /* c=32767, left-shifted by 1 */
    MR = MR + SR0 * MY0 (UU);               /* (above) + a(lo)*x(lo) + c */
    SR = ashift MR2 by 15 (HI);
    SR = SR or lshift MR1 by -1 (HI);       /* right-shift by 1 */
    SR = SR or lshift MR0 by -1 (LO);

    DM(v_MSWSeed) = SR1;                    /* save new MSW of seed */
    DM(v_LSWSeed) = SR0;                    /* save new LSW of seed */
    
    DM(I7, M6) = SR0;

    rts;
        
.ENDMOD;
