/******************************************************************************
*
*  SongPtrs.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  sets pointers used in main processing loop.  called every time a new song
*  begins (either the last one ends or IRQE function entered and v_NextSong
*  set to 1).
*
******************************************************************************/

.MODULE                                     modSongPtrs;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "ex1.h"

/*
 *  external variables and functions
 */

.EXTERNAL   InitGMParams_00;
.EXTERNAL   GenFX_00;
.EXTERNAL   SetFABCNTR_00;
.EXTERNAL   ModFuncs_00;
.EXTERNAL   Mixer_00;
.EXTERNAL   Env_00;

/*
 *  entry points
 */

.ENTRY      SongPtrs;
.ENTRY      CurrSongJT;
.ENTRY      DummyRet;

SongPtrs:
    AR = DM(v_CurrSong);
    M5 = AR;
    I5 = ^CurrSongJT;
    modify(I5, M5);
    jump (I5);

/* 
 *  jump table of all songs.  once one song ends, the Ptr memory locations are
 *  loaded with the pointers for the next song in the list.  this list is
 *  configured by default to run circularly (after the last song plays the
 *  first one starts again, but it can be changed my modifying the code at the
 *  label NextSong.
 */

CurrSongJT:

    jump Song_00;

Song_00:    
    AR = ^InitGMParams_00;
    DM(InitGMParamsPtr) = AR;

    AR = ^GenFX_00;
    DM(GenFXPtr) = AR;
    
    AR = ^SetFABCNTR_00;
    DM(SetFABCNTRPtr) = AR;
    
    AR = ^ModFuncs_00;
    DM(ModFuncsPtr) = AR;
    
    AR = ^Mixer_00;
    DM(MixerProcPtr) = AR;
        
    AR = ^Env_00;
    DM(EnvProcPtr) = AR;
    
    jump NextSong;

NextSong:
    AR = DM(v_CurrSong);
    AR = AR + 1;
    AY0 = DM(v_NumSongs);
    NONE = AR - AY0;
    if GE AR = pass 0;
    DM(v_CurrSong) = AR;

DummyRet:
    rts;
    
.ENDMOD;
