/******************************************************************************
*
*  GenFXIni.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  initialization of all generators, fx, envelopes and sequencer.  called at
*  the beginning of the song before audio output.  extensive post processing
*  and analysis occurs on this function, so follow the guidelines on usage as
*  outlined in the documentation.
*
******************************************************************************/

.MODULE                                     modGenFXIni_00;

/*
 *  include files for all functions
 */
 

#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "ex4.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      InitGMParams_00;
.ENTRY      EndInitGMParams_00;

InitGMParams_00:
    /* insert generators and fx initializations here */
    SETPTR(a_WTGen2);
    INIT_WTGEN2(0, ^a_WTSaw);
    INIT_WTGEN2(0, ^a_WTSaw);
    INIT_WTGEN2(0, ^a_WTSaw);
    
    INIT_WTGEN2(0, ^a_WTSine);
    INIT_WTGEN2(0, ^a_WTSine);
    
    SETPTR(a_RotSynthGen);
    INIT_ROTSYNTHGEN(8, 1, 0xabcd);
    INIT_ROTSYNTHGEN(8, 1, 0xabcd);
    
    SETPTR(a_ProbKSGen);
    INIT_PROBKSGEN(0x0000, 0x7fff, 0x7fff, 0x4000, 300, ^a_KSBuff0);
    INIT_PROBKSGEN(0x0000, 0x7fff, 0x7fff, 0x4000, 150, ^a_KSBuff1);

    SETPTR(a_FM2Op0Gen);
    INIT_FM2OP0GEN(555, ^a_WTSine, 0, 128, 0x0010, 0x0010, 0x0000, 0, 0x0000, 5000, 0, ^a_WTSine);
    INIT_FM2OP0GEN(666, ^a_WTSine, 0, 128, 0x0010, 0x0010, 0x0000, 0, 0x0000, 6000, 0, ^a_WTSine);
    
    SETPTR(a_GenSHFX);
    INIT_GENSHFX(4);
    INIT_GENSHFX(4);
    
    SETPTR(a_WaveShapeFX);
    INIT_WAVESHAPEFX(WAVESHAPEFX_CONTINUOUS, 0x3000, 18, 0x0000, 0, 0x0c00);
    INIT_WAVESHAPEFX(WAVESHAPEFX_CONTINUOUS, 0x3000, 18, 0x0000, 0, 0x0c00);
    
    SETPTR(a_PrevCurrFiltFX);
    INIT_PREVCURRFILTFX(PREVCURRFILTFX_1, 0);
    INIT_PREVCURRFILTFX(PREVCURRFILTFX_1, 0);
    
    SETPTR(a_LFO3);
    INIT_LFO3(1, 5000, ^a_WTSine, 8, 6, ^a_RotSynthGen+((0*ROTSYNTHGEN_VARS)+ROTSYNTHGEN_COUNT));
    INIT_LFO3(15, 5000, ^a_RandLUT, 0x0000, 0x4000, ^a_RotSynthGen+((0*ROTSYNTHGEN_VARS)+ROTSYNTHGEN_VAL));
    INIT_LFO3(1, 5000, ^a_WTSine, 8, 6, ^a_RotSynthGen+((1*ROTSYNTHGEN_VARS)+ROTSYNTHGEN_COUNT));
    INIT_LFO3(15, 5000, ^a_RandLUT, 0x0000, 0x4000, ^a_RotSynthGen+((1*ROTSYNTHGEN_VARS)+ROTSYNTHGEN_VAL));
    
    INIT_LFO3(87, 16, ^a_WTSine, 0x0300, 0x0180, ^a_PrevCurrFiltFX+((0*PREVCURRFILTFX_VARS)+PREVCURRFILTFX_MAXDIFF));
    INIT_LFO3(116, 16, ^a_WTSine, 0x0600, 0x0300, ^a_PrevCurrFiltFX+((1*PREVCURRFILTFX_VARS)+PREVCURRFILTFX_MAXDIFF));
    
    INIT_LFO3(5, 4928, ^a_WTSine, 5, 3, ^a_RotSynthGen+((0*GENSHFX_VARS)+GENSHFX_HOLDPER));
    INIT_LFO3(5, 5391, ^a_WTSine, 5, 3, ^a_RotSynthGen+((1*GENSHFX_VARS)+GENSHFX_HOLDPER));

    SETPTR(a_MemEnv2);
    INIT_MEMENV2(^a_WTGen2+(3*WTGEN2_VARS)+WTGEN2_FREQ, 1000, 20, 0x1000, 0x0800, 0x0400, 1, 0x6400, 1, 0x7c00, 1, 0x7f00, 1, 0x7f80);
    INIT_MEMENV2(^a_WTGen2+(4*WTGEN2_VARS)+WTGEN2_FREQ, 400, 20, 0x1000, 0x0800, 0x0400, 1, 0x6400, 1, 0x7c00, 1, 0x7f00, 1, 0x7f80);
    
    SETPTR(a_ADSRPanEnv);
    INIT_ADSRPANENV(128, 0x7fff, 0x0001, 0x7ffe, 58, 0x7ffe, 0x3000);
    INIT_ADSRPANENV(128, 0x7fff, 0x0001, 0x7ffe, 58, 0x7ffe, 0x5000);
    INIT_ADSRPANENV(128, 0x0010, 0x0010, 0x0000, 0,  0x0000, 0x4000);
    INIT_ADSRPANENV(128, 0x0008, 0x0008, 0x0000, 0,  0x0000, 0x4000);
    
    SETPTR(a_ExpDecayEnv);
    INIT_EXPDECAYENV(16, 0x7fa0, 0x4000);
    INIT_EXPDECAYENV(16, 0x7fa0, 0x4000);
    INIT_EXPDECAYENV(16, 0x7fa0, 0x4000);
    
    INIT_EXPDECAYENV(16, 0x7fb0, 0x2000);
    INIT_EXPDECAYENV(16, 0x7fb0, 0x6000);
    
    INIT_EXPDECAYENV(16, 0x7fc0, 0x4000);
    INIT_EXPDECAYENV(16, 0x7fe0, 0x4000);
    
    INIT_EXPDECAYENV(16, 0x7f90, 0x3000);
    INIT_EXPDECAYENV(16, 0x7f90, 0x5000);
    
/* SETTRACK(CLEAR, 0, 0,  a-a- a-a- a-a- a-a-  a--- ---- ---- ----,
            CLEAR, 0, 1,  a-a- a-a- a-a- a-a-  a--- ---- ---- ----,
            CLEAR, 0, 2,  a-a- a-a- a-a- a-a-  a--- ---- ---- ----,
            CLEAR, 0, 3,  ---- ---- ---- ----  ---- ---- b--- ----,
            CLEAR, 0, 4,  ---- ---- ---- ----  ---- ---- b--- ----,
            CLEAR, 0, 5,  ---- ---- c--- ----  ---- --c- ---- c---,
            CLEAR, 0, 6,  d--- --d- ---- d---  ---- ---- d--- ----,
            CLEAR, 0, 7,  ---- e--- ---- e---  ---- e--- ---- e---,
            CLEAR, 0, 8,  ---- e--- ---- e---  ---- e--- ---- e---,
            CLEAR, 0, 9,  f-f- --ff f--- f-f-  --f- f--- f-f- f-f-,
            CLEAR, 0, 10, f-f- --ff f--- f-f-  --f- f--- f-f- -ff-,
            CLEAR, 0, 11, g--- ---- ---- ----  ---- ---- ---- ----,
            CLEAR, 0, 12, g--- ---- ---- ----  ---- ---- ---- ----,
            a, 100, 0x0600,
            b, 100, 0x0800,
            c, 100, 0x2000,
            d, 100, 0x1800,
            e, 100, 0x00a0,
            f, 100, 0x0000,
            g, 100, 0x0200,
            END); */

    SETPTR(ap_CTRLTrack00);
    NUMCTRLTRACKS(NUMCTRLTRACK00);
    INIT_AP_CTRLTRACK(LENCTRLTRACK00_0, ^a_CTRLTrack00_0);
    
    SETPTR(ap_CTRLTrack01);
    NUMCTRLTRACKS(NUMCTRLTRACK01);
    INIT_AP_CTRLTRACK(LENCTRLTRACK01_0, ^a_CTRLTrack01_0);
    
    SETPTR(ap_CTRLTrack02);
    NUMCTRLTRACKS(NUMCTRLTRACK02);
    INIT_AP_CTRLTRACK(LENCTRLTRACK02_0, ^a_CTRLTrack02_0);

    AR = DM(a_MIDIFreq+C_2);
    DM(a_CTRLTrack00_0+0) = AR;
    AR = DM(a_MIDIFreq+CS_2);
    DM(a_CTRLTrack00_0+2) = AR;
    AR = DM(a_MIDIFreq+D_2);
    DM(a_CTRLTrack00_0+4) = AR;
    AR = DM(a_MIDIFreq+DS_2);
    DM(a_CTRLTrack00_0+6) = AR;
    AR = DM(a_MIDIFreq+E_2);
    DM(a_CTRLTrack00_0+8) = AR;
    AR = DM(a_MIDIFreq+DS_2);
    DM(a_CTRLTrack00_0+10) = AR;
    AR = DM(a_MIDIFreq+D_2);
    DM(a_CTRLTrack00_0+12) = AR;
    AR = DM(a_MIDIFreq+CS_2);
    DM(a_CTRLTrack00_0+14) = AR;
    AR = DM(a_MIDIFreq+C_2);
    DM(a_CTRLTrack00_0+16) = AR;
    
    AR = DM(a_MIDIFreq+G_2);
    DM(a_CTRLTrack02_0+0) = AR;
    AR = DM(a_MIDIFreq+GS_2);
    DM(a_CTRLTrack02_0+2) = AR;
    AR = DM(a_MIDIFreq+A_2);
    DM(a_CTRLTrack02_0+4) = AR;
    AR = DM(a_MIDIFreq+AS_2);
    DM(a_CTRLTrack02_0+6) = AR;
    AR = DM(a_MIDIFreq+B_2);
    DM(a_CTRLTrack02_0+8) = AR;
    AR = DM(a_MIDIFreq+AS_2);
    DM(a_CTRLTrack02_0+10) = AR;
    AR = DM(a_MIDIFreq+A_2);
    DM(a_CTRLTrack02_0+12) = AR;
    AR = DM(a_MIDIFreq+GS_2);
    DM(a_CTRLTrack02_0+14) = AR;
    AR = DM(a_MIDIFreq+G_2);
    DM(a_CTRLTrack02_0+16) = AR;
        
    AR = DM(a_MIDIFreq+E_2);
    DM(a_CTRLTrack01_0+0) = AR;
    AR = DM(a_MIDIFreq+F_2);
    DM(a_CTRLTrack01_0+2) = AR;
    AR = DM(a_MIDIFreq+FS_2);
    DM(a_CTRLTrack01_0+4) = AR;
    AR = DM(a_MIDIFreq+G_2);
    DM(a_CTRLTrack01_0+6) = AR;
    AR = DM(a_MIDIFreq+GS_2);
    DM(a_CTRLTrack01_0+8) = AR;
    AR = DM(a_MIDIFreq+G_2);
    DM(a_CTRLTrack01_0+10) = AR;
    AR = DM(a_MIDIFreq+FS_2);
    DM(a_CTRLTrack01_0+12) = AR;
    AR = DM(a_MIDIFreq+F_2);
    DM(a_CTRLTrack01_0+14) = AR;
    AR = DM(a_MIDIFreq+E_2);
    DM(a_CTRLTrack01_0+16) = AR;
    
/*
 *  init sequencer array
 *  
 *  param0:  tic period
 *  param1:  swing period (num tics between slow/fast transition)
 *  param2:  swing amount
 *  param3:  sequencer length
 *  param4:  ptr to TrigInit function
 *  param5:  envelope type
 *  param6:  aux function ptr
 *
 */

    SETPTR(a_Seq2);
    modify(I2, M1);                         /* numtrax set by CalcSeq2Tracks */
    
    INIT_SEQ2(29, 0, 0, 32, EXPDECAYENV);
    INIT_SEQ2(29, 0, 0, 32, EXPDECAYENV);
    INIT_SEQ2(29, 0, 0, 32, EXPDECAYENV);
    
    INIT_SEQ2(29 , 0, 0, 32, EXPDECAYENV);
    INIT_SEQ2(29, 0, 0, 32, EXPDECAYENV);
    
    INIT_SEQ2(29, 0, 0, 32, EXPDECAYENV);
    INIT_SEQ2(29, 0, 0, 32, EXPDECAYENV);
    
    INIT_SEQ2(29, 0, 0, 32, ADSRENV);
    INIT_SEQ2(29, 0, 0, 32, ADSRENV);
    
    INIT_SEQ2(29, 0, 0, 32, EXPDECAYENV);
    INIT_SEQ2(29, 0, 0, 32, EXPDECAYENV);
    
    INIT_SEQ2(29*4, 0, 0, 32, ADSRENV);
    INIT_SEQ2(29*8, 0, 0, 32, ADSRENV);

    /* must be called after Seq2 init to set env and num tracks */
    call Seq2PostProc;
    
    /* set v_TicsPerMeasure to length of first sequence */
    SEQ2_SET_MEASURE(0);

    AR = ^InitGMParams_00;
    AX0 = ^EndInitGMParams_00;
    call FillGenFXPtrInits;
    
    /* init ^Env and set length of array of ptrs used in GenFXPtrInits */
    call GenFXIniPostProc;                  /* do not remove! */
    
EndInitGMParams_00:
    rts;

.ENDMOD;
