/******************************************************************************
*
*  GenFXIni.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  initialization of all generators, fx, envelopes and sequencer.  called at
*  the beginning of the song before audio output.  extensive post processing
*  and analysis occurs on this function, so follow the guidelines on usage as
*  outlined in the documentation.
*
******************************************************************************/

.MODULE                                     modGenFXIni_00;

/*
 *  include files for all functions
 */
 

#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "exp2_3.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      InitGMParams_00;
.ENTRY      EndInitGMParams_00;

InitGMParams_00:
    /* insert generators and fx initializations here */
    SETPTR(a_WTGen2);
    INIT_WTGEN2(0, ^a_WTSine);
    INIT_WTGEN2(0, ^a_WTSine);
    INIT_WTGEN2(0, ^a_WTSaw);
    INIT_WTGEN2(C_3, ^a_WTSaw);
    INIT_WTGEN2(0, ^a_WTSq);
    INIT_WTGEN2(0, ^a_WTSq);
    INIT_WTGEN2(131, ^a_WTSaw);
    INIT_WTGEN2(262, ^a_WTSaw);
    
    SETPTR(a_KSGen);
    INIT_KSGEN(0x0001, ^a_KSBuff0, 0x1ff, 0x0000, 0x3c00);
    INIT_KSGEN(0x0001, ^a_KSBuff1, 0x1ff, 0x0000, 0x3c00);
    INIT_KSGEN(0x0000, ^a_KSBuff2, 0x3f, 0x0000, 0x5000);
    INIT_KSGEN(0x0000, ^a_KSBuff3, 0x3f, 0x0000, 0x5000);
    
    SETPTR(a_GenSHFX);
    INIT_GENSHFX(3);
    INIT_GENSHFX(3);
    
    SETPTR(a_FM2Op0Gen);
    INIT_FM2OP0GEN(392, ^a_WTSine, 0, 64, 0x7fff, 0x0040, 0x0000, 0, 0x0000, 784, 0, ^a_WTTri);
    INIT_FM2OP0GEN(784, ^a_WTSine, 0, 64, 0x7fff, 0x0040, 0x0000, 0, 0x0000, 784*2, 0, ^a_WTTri);

    SETPTR(a_SVFFX);
    INIT_SVFFX(0x2000, 0x2000, 0x2000, SVFFX_HIGHOUT);
    INIT_SVFFX(0x2000, 0x2000, 0x2000, SVFFX_HIGHOUT);
    INIT_SVFFX(0x1000, 0x0000, 0x0000, SVFFX_LOWOUT);
    INIT_SVFFX(0x7000, 0x0000, 0x0000, SVFFX_LOWOUT);
    INIT_SVFFX(0x7000, 0x0000, 0x0000, SVFFX_LOWOUT);
    INIT_SVFFX(0x0100, 0x1400, 0x1400, SVFFX_LOWOUT);
    INIT_SVFFX(0x0100, 0x2800, 0x2800, SVFFX_LOWOUT);
    INIT_SVFFX(0x0100, 0x2000, 0x2000, SVFFX_LOWOUT);
    INIT_SVFFX(0x0100, 0x2000, 0x2000, SVFFX_LOWOUT);
    
    SETPTR(a_ExpDecayEnv);
    INIT_EXPDECAYENV(4, 0x7ff0, 0x4800);        ! bd0
    INIT_EXPDECAYENV(12, 0x7ff0, 0x3800);       ! bd1
    INIT_EXPDECAYENV(12, 0x7f00, 0x4000);       ! rhythmsaw
    INIT_EXPDECAYENV(16, 0x7ff0, 0x1000);       ! hh1
    INIT_EXPDECAYENV(16, 0x7ff0, 0x7000);       ! hh1
    INIT_EXPDECAYENV(16, 0x7ff0, 0x2000);       ! hh2
    INIT_EXPDECAYENV(16, 0x7ff0, 0x6000);       ! hh2
    INIT_EXPDECAYENV(8, 0x7fa0, 0x4000);        ! sawlead0
    INIT_EXPDECAYENV(16, 0x7fa0, 0x4000);       ! sawlead1
    INIT_EXPDECAYENV(32, 0x7fe0, 0x4000);       ! warblelead
    INIT_EXPDECAYENV(32, 0x7fe0, 0x4000);       ! warblelead
    INIT_EXPDECAYENV(32, 0x7fa0, 0x4000);       ! fmrhythm
    INIT_EXPDECAYENV(32, 0x7fb0, 0x4000);       ! fmrhythm
    
    SETPTR(a_MemEnv2);
    INIT_MEMENV2(^a_WTGen2+(0*WTGEN2_VARS)+WTGEN2_FREQ, 700, 20, 0x1000, 0x0800, 0x0400, 1, 0x6400, 1, 0x7c00, 1, 0x7f00, 1, 0x7f80);
    !INIT_MEMENV2(^a_WTGen2+(1*WTGEN2_VARS)+WTGEN2_FREQ, 400, 20, 0x1000, 0x0800, 0x0400, 1, 0x6400, 1, 0x7c00, 1, 0x7f00, 1, 0x7f80);
    INIT_MEMENV2(^a_WTGen2+(1*WTGEN2_VARS)+WTGEN2_FREQ, 525, 20, 0x1000, 0x0800, 0x0400, 1, 0x6400, 1, 0x7c00, 1, 0x7f00, 1, 0x7f80);
    
    SETPTR(a_MemEnv3);
    INIT_MEMENV3(^a_WTGen2+(2*WTGEN2_VARS)+WTGEN2_FREQ, 700, 700, 1, 600, 80);
    INIT_MEMENV3(^a_LFO3+(2*LFO3_VARS)+LFO3_MOD, 0x0800, 0x0800, 1, 0x0800, 42);
    INIT_MEMENV3(^a_LFO3+(3*LFO3_VARS)+LFO3_MOD, 0x0800, 0x0800, 1, 0x0800, 42);
    INIT_MEMENV3(^a_LMixScalars+0,  0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+0,  0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+5,  0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+5,  0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+6,  0x0000, 0x0000, 1, 0x0000, 1);
    
    INIT_MEMENV3(^a_RMixScalars+6,  0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+14, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+14, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+7,  0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+7,  0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+8, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+8, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+1, 0x0000, 0x0000, 1, 0x0000, 1);
    
    INIT_MEMENV3(^a_RMixScalars+1, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+3, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+3, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+4, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+4, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+15, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+15, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LFO3+(0*LFO3_VARS)+LFO3_FREQ, 125, 625, 32*21*8, 375, 1);
    
    INIT_MEMENV3(^a_LFO3+(1*LFO3_VARS)+LFO3_FREQ, 125, 375, 32*21*8, 375, 1);
    INIT_MEMENV3(^a_LMixScalars+9, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+9, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+10, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+10, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+11, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+11, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+12, 0x0000, 0x0000, 1, 0x0000, 1);
    
    INIT_MEMENV3(^a_RMixScalars+12, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LMixScalars+13, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_RMixScalars+13, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^v_Dummy, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^v_Dummy, 0x0000, 0x0000, 1, 0x0000, 1);
    INIT_MEMENV3(^a_LFO3+(14*LFO3_VARS)+LFO3_MOD, 0x0000, 0x0000, 21*64*5, 0x0000, 1);
    INIT_MEMENV3(^a_LFO3+(15*LFO3_VARS)+LFO3_MOD, 0x0000, 0x0000, 21*64*5, 0x0000, 1);
    
        
    SETPTR(a_LFO3);
    INIT_LFO3(1, 125, ^a_WTSaw, 0x0e00, 0x1000, ^a_SVFFX+(2*SVFFX_VARS)+SVFFX_K3);
    INIT_LFO3(1, 125, ^a_WTSaw, 0x0e00, 0x1000, ^a_SVFFX+(2*SVFFX_VARS)+SVFFX_K4);
    INIT_LFO3(1, 250, ^a_WTSaw, 0x0800, 0x1000, ^a_SVFFX+(3*SVFFX_VARS)+SVFFX_K3);
    INIT_LFO3(1, 250, ^a_WTSaw, 0x0800, 0x1000, ^a_SVFFX+(3*SVFFX_VARS)+SVFFX_K4);
    INIT_LFO3(1, 250, ^a_WTSaw, 0x1800, 0x2000, ^a_SVFFX+(4*SVFFX_VARS)+SVFFX_K3);
    INIT_LFO3(1, 250, ^a_WTSaw, 0x1800, 0x2000, ^a_SVFFX+(4*SVFFX_VARS)+SVFFX_K4);
    
    INIT_LFO3(21, 2000, ^a_WTSaw, 20, 880*2, ^a_WTGen2+(6*WTGEN2_VARS)+WTGEN2_FREQ);
    INIT_LFO3(21, 4000, ^a_WTSaw, 30, 880*2, ^a_WTGen2+(7*WTGEN2_VARS)+WTGEN2_FREQ);
    
    INIT_LFO3(2, 125, ^a_WTSine, 0x1000, 0x4000, ^a_ExpDecayEnv+(9*EXPDECAYENV_VARS)+EXPDECAYENV_PAN);
    INIT_LFO3(4, 125, ^a_WTSine, 0x1000, 0x4000, ^a_ExpDecayEnv+(10*EXPDECAYENV_VARS)+EXPDECAYENV_PAN);
    
    INIT_LFO3(8, 125, ^a_WTSine, 20, 784, ^a_FM2Op0Gen+(0*FM2OP0_VARS)+FM2OP0_BASECARR);
    INIT_LFO3(16, 125, ^a_WTSine, 40, 784*2, ^a_FM2Op0Gen+(1*FM2OP0_VARS)+FM2OP0_BASECARR);
    
    INIT_LFO3(1, 1000, ^a_WTSq, 2, 4, ^a_GenSHFX+(0*GENSHFX_VARS)+GENSHFX_HOLDPER);
    INIT_LFO3(1, 1000, ^a_WTSq, 2, 4, ^a_GenSHFX+(1*GENSHFX_VARS)+GENSHFX_HOLDPER);
    
    INIT_LFO3(8, 125, ^a_WTSine, 0, 0x3000, ^a_ExpDecayEnv+(11*EXPDECAYENV_VARS)+EXPDECAYENV_PAN);
    INIT_LFO3(8, 125, ^a_WTSine, 0, 0x5000, ^a_ExpDecayEnv+(12*EXPDECAYENV_VARS)+EXPDECAYENV_PAN);
    
    SETPTR(a_ADSRPanEnv);
    INIT_ADSRPANENV(128, 0x0100, 0x7fff, 0x0000, 0, 0x0000, 0x2000);
    INIT_ADSRPANENV(128, 0x0100, 0x7fff, 0x0000, 0, 0x0000, 0x6000);
    INIT_ADSRPANENV(128, 0x7fff, 0x0000, 0x0000, 0, 0x0000, 0x4000);
           
    /* init TrigTrack and VolTrack arrays as needed */    

    AR = 0;
    DM(p_LeadNotes0) = AR;
    AR = 0;
    DM(p_LeadNotes1) = AR;
    
    AR = 100;
    DM(v_KeepLeadFreq0) = AR;
    DM(v_KeepLeadFreq1) = AR;
    
    DM(v_IncLeadFreq0) = M0;
    DM(v_IncLeadFreq1) = M0;
    DM(v_DecLeadFreq0) = M0;
    DM(v_DecLeadFreq1) = M0;
    
    DM(v_PadMask) = M0;
    
    AR = 70;
    DM(v_NoiseFiltFreq) = AR;
    
    DM(v_LowOrHighBassNote) = M0;
    
    AR = 70;
    DM(v_ProbLowGenSHFX) = AR;
    
/*
 *  init sequencer array
 *  
 *  param0:  tic period
 *  param1:  swing period (num tics between slow/fast transition)
 *  param2:  swing amount
 *  param3:  sequencer length
 *  param4:  ptr to TrigInit function
 *  param5:  envelope type
 *  param6:  aux function ptr
 *
 */

    SETPTR(a_Seq2);
    modify(I2, M1);                         /* numtrax set by CalcSeq2Tracks */

    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 56, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, ADSRENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, ADSRENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE*8, 0, 0, 64, ADSRENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE*2, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE*4, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE*4, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(EXP2_3BASERATE, 0, 0, 64, EXPDECAYENV);

    /* must be called after Seq2 init to set env and num tracks */
    call Seq2PostProc;
    
    /* set v_TicsPerMeasure to length of first sequence */
    SEQ2_SET_MEASURE(0);

    AR = ^InitGMParams_00;
    AX0 = ^EndInitGMParams_00;
    call FillGenFXPtrInits;
    
    /* init ^Env and set length of array of ptrs used in GenFXPtrInits */
    call GenFXIniPostProc;                  /* do not remove! */
    
EndInitGMParams_00:
    rts;

.ENDMOD;
