/******************************************************************************
*
*  GenFX.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  contains calls to generators and FX, along with mixer function.
*
******************************************************************************/

.MODULE                                     modGenFX_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "exp2_3.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      GenFX_00;
.ENTRY      Env_00;
.ENTRY      Mixer_00;

GenFX_00:
    /* insert generators and fx here */
    call WTGen2;
    modify(I7, M7);                     /* bd0 */
    
    call WTGen2;
    modify(I7, M7);                     /* bd0 */
    
    call WTGen2;
    modify(I7, M7);                     /* rhythmsaw */
    
    AR = DM(I6, M7);
    DM(I7,M6) = AR;
    call SVFFX;
    modify(I7, M7);                     /* hh0 */
    
    AR = DM(I6, M7);
    DM(I7,M6) = AR;
    call SVFFX;
    modify(I7, M7);                     /* hh0 */
    
    call KSGen;
    call GenSHFX;
    modify(I7, M7);                     /* hh1 */
    
    call KSGen;
    call GenSHFX;
    modify(I7, M7);                     /* hh1 */
    
    call KSGen;
    modify(I7, M7);                     /* hh2 */
    
    call KSGen;
    modify(I7, M7);                     /* hh2 */
    
    call WTGen2;
    call SVFFX;
    modify(I7, M7);                     /* bass */
    
    call WTGen2;
    call SVFFX;
    modify(I7, M7);                     /* lead0 */
    
    call WTGen2;
    call SVFFX;
    modify(I7, M7);                     /* lead1 */
    
    call WTGen2;
    call SVFFX;
    modify(I7, M7);                     /* pad0 */

    call WTGen2;
    call SVFFX;
    modify(I7, M7);                     /* pad1 */
    
    call FM2Op0Gen;
    call SVFFX;
    modify(I7, M7);
    
    call FM2Op0Gen;
    call SVFFX;
    modify(I7, M7);
                   
    /* move ptr back to top of a_GenData for scaling */
    AR = ^a_GenData;
    DM(p_GenData) = AR;
    
    /* stop borrowing I7 for a_GenData */
    I7 = ^a_RSampOut;
    L7 = %a_RSampOut;
    
/*
 *  envelopes automatically placed by GenFXIniPostProc - max num of tracks set
 *  by MAXTRACKS.  if this value is changed, muts add more nop to accomidate
 */

Env_00:
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
    nop;    nop;    nop;    nop;
        
    rts;


/*
 *  final mix of all tracks.  LBasicMix/RBasicMix are included in
 *  .\gen_fx\Mixer.dsp, which perform a simple mix function, along with
 *  multiplying by the global scalars in a_RMixScalars/a_LMixScalars.  other
 *  mixing functions are possible, such as submixes and FX on groups of tracks.
 *  additionally, any sort of global FX can be inserted immediately after the
 *  call the basic mix functions.
 *
 *  if any new mixing functions are written, they should be placed directly in
 *  this file, or in another file within the project directory.  in general, the
 *  less files in the gen_fx directory are modified, the better.  plus, if
 *  changes are made in Mixer.dsp, they will be reflected in all projects built
 *  from the root.
 */

Mixer_00:
    call LBasicMix;
      
    /* insert global LChan processing here (any FX functions) */
    
    /* readback from I7, write data to output array.  do not remove! */
    AR = DM(I7, M6);
    I7 = DM(p_LOutBuff);                /* get ptr to LOutBuff */
    L7 = OUTBUFFLEN;
    DM(I7, M7) = AR;                    /* write output to OutBuff0 or 1 */
    DM(p_LOutBuff) = I7;                /* update ptr */
    
    call RBasicMix;
      
    /* insert global RChan processing here (any FX functions) */

    /* readback from I7, write data to output array.  do not remove! */
    AR = DM(I7, M6);
    I7 = DM(p_ROutBuff);                /* get ptr to ROutBuff */
    L7 = OUTBUFFLEN;
    DM(I7, M7) = AR;                    /* write output to OutBuff0 or 1 */
    DM(p_ROutBuff) = I7;                /* update ptr */
    
    rts;

.ENDMOD;
