/******************************************************************************
*
*  GenFXIni.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  initialization of all generators, fx, envelopes and sequencer.  called at
*  the beginning of the song before audio output.  extensive post processing
*  and analysis occurs on this function, so follow the guidelines on usage as
*  outlined in the documentation.
*
******************************************************************************/

.MODULE                                     modGenFXIni_00;

/*
 *  include files for all functions
 */
 

#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "flb.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      InitGMParams_00;
.ENTRY      EndInitGMParams_00;

InitGMParams_00:
    /* insert generators and fx initializations here */

    SETPTR(a_WTGen2);
    INIT_WTGEN2(0, ^a_WTSine);
    INIT_WTGEN2(0, ^a_WTSine);
    INIT_WTGEN2(0, ^a_WTSine);
    INIT_WTGEN2(0, ^a_WTSine);
    INIT_WTGEN2(0, ^a_WTSine);
    INIT_WTGEN2(0, ^a_WTSine);
    INIT_WTGEN2(0, ^a_WTSine);
    
    SETPTR(a_FM2Op0Gen);
    INIT_FM2OP0GEN(150, ^a_WTSine, 0, 128, 0x0004, 0, 0x7fff, 0x7fff, 0, 1200, 75, ^a_WTSine);
    INIT_FM2OP0GEN(150, ^a_WTSine, 0, 128, 0x0004, 0, 0x7fff, 0x7fff, 0, 2400, 75, ^a_WTSine);
    INIT_FM2OP0GEN(150, ^a_WTSine, 0, 128, 0x0004, 0, 0x7fff, 0x7fff, 0, 1200, 75, ^a_WTSine);
    INIT_FM2OP0GEN(150, ^a_WTSine, 0, 128, 0x0004, 0, 0x7fff, 0x7fff, 0, 2400, 75, ^a_WTSine);
        
    SETPTR(a_ProbKSGen);
    INIT_PROBKSGEN(0x2000, 0x7fff, 0x7fff, 0x4001, 294, ^a_KSBuff0);
    INIT_PROBKSGEN(0x2000, 0x7fff, 0x7fff, 0x4001, 294, ^a_KSBuff1);
    INIT_PROBKSGEN(0x2000, 0x7fff, 0x7fff, 0x4001, 294, ^a_KSBuff2);
    INIT_PROBKSGEN(0x2000, 0x7fff, 0x7fff, 0x4001, 294, ^a_KSBuff3);

    SETPTR(a_MemEnv2);
    INIT_MEMENV2(^a_WTGen2+(6*WTGEN2_VARS)+WTGEN2_FREQ, 700, 20, 0x1000, 0x0800, 0x0400, 1, 0x6400, 1, 0x7c00, 1, 0x7f00, 1, 0x7f80);

    SETPTR(a_ADSRPanEnv);
    INIT_ADSRPANENV(16, 0x1fff, 0x0100, 0x0800, 4800, 0x0001, 0x4000);
    INIT_ADSRPANENV(16, 0x1fff, 0x0100, 0x0800, 6400, 0x0001, 0x4000);
    INIT_ADSRPANENV(16, 0x1fff, 0x0100, 0x0800, 8000, 0x0001, 0x4000);
    INIT_ADSRPANENV(16, 0x1fff, 0x0100, 0x0800, 4800, 0x0001, 0x4000);
    INIT_ADSRPANENV(16, 0x1fff, 0x0100, 0x0800, 6400, 0x0001, 0x4000);
    INIT_ADSRPANENV(16, 0x1fff, 0x0100, 0x0800, 8000, 0x0001, 0x4000);
    
    ! ks0l & ks0r
    INIT_ADSRPANENV(128, 0x0003, 0x0030, 0x0000, 0x7fff, 0x0000, 0x2000);
    INIT_ADSRPANENV(128, 0x0003, 0x0030, 0x0000, 0x7fff, 0x0000, 0x6000);
    
    ! fm0 & fm1
    INIT_ADSRPANENV(128, 0x0008, 0x0008, 0x0000, 0x7fff, 0x0000, 0x4000);
    INIT_ADSRPANENV(128, 0x0008, 0x0008, 0x0000, 0x7fff, 0x0000, 0x4000);
    
    ! ks1l & ks1r
    INIT_ADSRPANENV(128, 0x0003, 0x0030, 0x0000, 0x7fff, 0x0000, 0x2000);
    INIT_ADSRPANENV(128, 0x0003, 0x0030, 0x0000, 0x7fff, 0x0000, 0x6000);
    
    ! fm2 & fm3
    INIT_ADSRPANENV(128, 0x0008, 0x0008, 0x0000, 0x7fff, 0x0000, 0x4000);
    INIT_ADSRPANENV(128, 0x0008, 0x0008, 0x0000, 0x7fff, 0x0000, 0x4000);
    
    INIT_ADSRPANENV(128, 0x7fff, 0x0800, 0x0800, 25, 0x0040, 0x6000);
    INIT_ADSRPANENV(128, 0x7fff, 0x0800, 0x0800, 25, 0x0040, 0x2000);
    
    SETPTR(a_ExpDecayEnv);
    INIT_EXPDECAYENV(4, 0x7ff0, 0x4000);        ! bd0    
    !INIT_EXPDECAYENV(4, 0x7ff0, 0x2000);        ! noise0
    !INIT_EXPDECAYENV(4, 0x7ff0, 0x6000);        ! noise1

    SETPTR(a_LFO3);
    INIT_LFO3(1, 5000, ^a_RandLUT, 0, 300, ^a_WTGen2+(0*WTGEN2_VARS)+WTGEN2_FREQ);
    INIT_LFO3(1, 7000, ^a_RandLUT, 0, 450, ^a_WTGen2+(1*WTGEN2_VARS)+WTGEN2_FREQ);
    INIT_LFO3(1, 10000, ^a_RandLUT, 0, 600, ^a_WTGen2+(2*WTGEN2_VARS)+WTGEN2_FREQ);
    INIT_LFO3(1, 12000, ^a_RandLUT, 0, 750, ^a_WTGen2+(3*WTGEN2_VARS)+WTGEN2_FREQ);
    INIT_LFO3(1, 15000, ^a_RandLUT, 0, 900, ^a_WTGen2+(4*WTGEN2_VARS)+WTGEN2_FREQ);
    INIT_LFO3(1, 17000, ^a_RandLUT, 0, 1200, ^a_WTGen2+(5*WTGEN2_VARS)+WTGEN2_FREQ);
    
    INIT_LFO3(1, 12000, ^a_WTSine, 400, 800, ^a_Seq2+1+(0*SEQ2_VARS)+SEQ2_TRIGRATE);
    INIT_LFO3(1, 9000, ^a_WTSine, 600, 1200, ^a_Seq2+1+(1*SEQ2_VARS)+SEQ2_TRIGRATE);
    INIT_LFO3(1, 6000, ^a_WTSine, 300, 600, ^a_Seq2+1+(2*SEQ2_VARS)+SEQ2_TRIGRATE);
    INIT_LFO3(1, 4000, ^a_WTSine, 800, 1600, ^a_Seq2+1+(3*SEQ2_VARS)+SEQ2_TRIGRATE);
    INIT_LFO3(1, 8000, ^a_WTSine, 500, 1000, ^a_Seq2+1+(4*SEQ2_VARS)+SEQ2_TRIGRATE);
    INIT_LFO3(1, 15000, ^a_WTSine, 1000, 2000, ^a_Seq2+1+(5*SEQ2_VARS)+SEQ2_TRIGRATE);

    SETPTR(a_MemEnv3);
    /*
    INIT_MEMENV3(^a_LFO3+(0*LFO3_VARS)+LFO3_MOD, 0, 50, 200, 50, 1);
    INIT_MEMENV3(^a_LFO3+(1*LFO3_VARS)+LFO3_MOD, 0, 50, 250, 50, 1);
    INIT_MEMENV3(^a_LFO3+(2*LFO3_VARS)+LFO3_MOD, 0, 50, 300, 50, 1);
    INIT_MEMENV3(^a_LFO3+(3*LFO3_VARS)+LFO3_MOD, 0, 50, 325, 50, 1);
    INIT_MEMENV3(^a_LFO3+(4*LFO3_VARS)+LFO3_MOD, 0, 50, 350, 50, 1);
    INIT_MEMENV3(^a_LFO3+(5*LFO3_VARS)+LFO3_MOD, 0, 50, 400, 50, 1);
    */
    INIT_MEMENV3(^a_LFO3+(0*LFO3_VARS)+LFO3_MOD, 50, 50, 1, 0, 200);
    INIT_MEMENV3(^a_LFO3+(1*LFO3_VARS)+LFO3_MOD, 50, 50, 1, 0, 250);
    INIT_MEMENV3(^a_LFO3+(2*LFO3_VARS)+LFO3_MOD, 50, 50, 1, 0, 300);
    INIT_MEMENV3(^a_LFO3+(3*LFO3_VARS)+LFO3_MOD, 50, 50, 1, 0, 325);
    INIT_MEMENV3(^a_LFO3+(4*LFO3_VARS)+LFO3_MOD, 50, 50, 1, 0, 350);
    INIT_MEMENV3(^a_LFO3+(5*LFO3_VARS)+LFO3_MOD, 50, 50, 1, 0, 400);
    
    INIT_MEMENV3(^a_ProbKSGen+(0*PROBKSGEN_VARS)+PROBKSGEN_FILTPROB, 0x2000, 0x2000, 1, 0x1000, 12000);
    INIT_MEMENV3(^a_ProbKSGen+(1*PROBKSGEN_VARS)+PROBKSGEN_FILTPROB, 0x2000, 0x2000, 1, 0x1000, 12000);
    
    INIT_MEMENV3(^a_ProbKSGen+(2*PROBKSGEN_VARS)+PROBKSGEN_FILTPROB, 0x2000, 0x2000, 1, 0x1000, 12000);
    INIT_MEMENV3(^a_ProbKSGen+(3*PROBKSGEN_VARS)+PROBKSGEN_FILTPROB, 0x2000, 0x2000, 1, 0x1000, 12000);
    
    AR = 100;
    AY0 = 0x1000;
    AX0 = 0x1100;
    AX1 = 0x1800;
    AY1 = 0x0200;
    SR0 = 0x0600;
    MR0 = 0x0080;
    MR1 = 0x0040;
    
    DM(a_TrigTrack00+0) = AR;
    DM(a_VolTrack00+0) = AY0;
    DM(a_TrigTrack01+0) = AR;
    DM(a_VolTrack01+0) = AY0;
    DM(a_TrigTrack02+0) = AR;
    DM(a_VolTrack02+0) = AY0;
    DM(a_TrigTrack03+0) = AR;
    DM(a_VolTrack03+0) = AY0;
    DM(a_TrigTrack04+0) = AR;
    DM(a_VolTrack04+0) = AY0;
    DM(a_TrigTrack05+0) = AR;
    DM(a_VolTrack05+0) = AY0;
    
    DM(a_TrigTrack06+0) = AR;
    DM(a_VolTrack06+0) = AX0;
    DM(a_TrigTrack06+2) = AR;
    DM(a_VolTrack06+2) = AX1;
    DM(a_TrigTrack07+0) = AR;
    DM(a_VolTrack07+0) = AX0;
    DM(a_TrigTrack07+2) = AR;
    DM(a_VolTrack07+2) = AX1;
    
    DM(a_TrigTrack08+0) = AR;
    DM(a_VolTrack08+0) = AY1;
    DM(a_TrigTrack09+0) = AR;
    DM(a_VolTrack09+0) = AY1;
    
    DM(a_TrigTrack10+0) = AR;
    DM(a_VolTrack10+0) = SR0;
    
    DM(a_TrigTrack11+1) = AR;
    DM(a_VolTrack11+1) = AX0;
    DM(a_TrigTrack11+3) = AR;
    DM(a_VolTrack11+3) = AX1;
    DM(a_TrigTrack12+1) = AR;
    DM(a_VolTrack12+1) = AX0;
    DM(a_TrigTrack12+3) = AR;
    DM(a_VolTrack12+3) = AX1;

    DM(a_TrigTrack13+1) = AR;
    DM(a_VolTrack13+1) = AY1;
    DM(a_TrigTrack14+1) = AR;
    DM(a_VolTrack14+1) = AY1;
    
    DM(a_TrigTrack15+0) = AR;
    DM(a_VolTrack15+0) = MR0;
    DM(a_TrigTrack15+1) = AR;
    DM(a_VolTrack15+1) = MR1;
    DM(a_TrigTrack16+0) = AR;
    DM(a_VolTrack16+0) = MR0;
    DM(a_TrigTrack16+1) = AR;
    DM(a_VolTrack16+1) = MR1;
    
    I2 = ^a_KS0LFreq;
    DM(I2, M1) = 294;
    DM(I2, M1) = 588;
    DM(I2, M1) = 881;
    DM(I2, M1) = 441;
    
    I2 = ^a_KS0RFreq;
    DM(I2, M1) = 587;
    DM(I2, M1) = 293;
    DM(I2, M1) = 440;
    DM(I2, M1) = 880;
    
    AR = ^a_KS0LFreq;
    DM(p_KS0LFreq) = AR;
    AR = ^a_KS0RFreq;
    DM(p_KS0RFreq) = AR;
    
/*
 *  init sequencer array
 *  
 *  param0:  tic period
 *  param1:  swing period (num tics between slow/fast transition)
 *  param2:  swing amount
 *  param3:  sequencer length
 *  param4:  ptr to TrigInit function
 *  param5:  envelope type
 *  param6:  aux function ptr
 *
 */

    SETPTR(a_Seq2);
    modify(I2, M1);                         /* numtrax set by CalcSeq2Tracks */
    
    !INIT_SEQ2(100, 0, 0, 1, ^InitSine0, ADSRENV, ^DummyRet);
    INIT_SEQ2(400, 0, 0, 1, ADSRENV);
    INIT_SEQ2(150, 0, 0, 1, ADSRENV);
    INIT_SEQ2(175, 0, 0, 1, ADSRENV);
    INIT_SEQ2(200, 0, 0, 1, ADSRENV);
    INIT_SEQ2(225, 0, 0, 1, ADSRENV);
    INIT_SEQ2(250, 0, 0, 1, ADSRENV);
    INIT_SEQ2(6000, 0, 0, 4, ADSRENV);
    INIT_SEQ2(6000, 0, 0, 4, ADSRENV);
    INIT_SEQ2(4000, 0, 0, 2, ADSRENV);
    INIT_SEQ2(4000, 0, 0, 2, ADSRENV);
    INIT_SEQ2(400, 0, 0, 1, EXPDECAYENV);
    INIT_SEQ2(6000, 0, 0, 4, ADSRENV);
    INIT_SEQ2(6000, 0, 0, 4, ADSRENV);
    INIT_SEQ2(4000, 0, 0, 2, ADSRENV);
    INIT_SEQ2(4000, 0, 0, 2, ADSRENV);
    INIT_SEQ2(200, 0, 0, 2, ADSRENV);
    INIT_SEQ2(200, 0, 0, 2, ADSRENV);

    /* must be called after Seq2 init to set env and num tracks */
    call Seq2PostProc;
    
    /* set v_TicsPerMeasure to length of first sequence */
    SEQ2_SET_MEASURE(0);

    AR = ^InitGMParams_00;
    AX0 = ^EndInitGMParams_00;
    call FillGenFXPtrInits;

    !MUTETRACK(0);
    !MUTETRACK(1);
    !MUTETRACK(2);
    !MUTETRACK(3);
    !MUTETRACK(4);
    !MUTETRACK(5);
    !MUTETRACK(8);
    !MUTETRACK(9);
    
    /* init ^Env and set length of array of ptrs used in GenFXPtrInits */
    call GenFXIniPostProc;                  /* do not remove! */
    
EndInitGMParams_00:
    rts;

.ENDMOD;
