/******************************************************************************
*
*  DelaySyn.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  delay line generator with n taps
*
*   param0:  length of delay line
*   param1:  ptr into delay line
*   param2:  num delay lines
*   param3-n:  coefficients for delay line filter
*
*   this generator is very similar to a KS generator but has variable # of taps
*
******************************************************************************/

.MODULE                                     modDelaySyn;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  external variables
 */

/*
 *  entry points
 */
 
.ENTRY      DelaySynthGen;

DelaySynthGen:
    I2 = DM(p_DelaySynthGen);
    AR = DM(I2, M1);
    L5 = AR;                                /* length of delay line */
    AX0 = DM(I2, M0);
    I5 = AX0;                               /* ptr into delay line */
    SI = I5;
    modify(I5, M7);                         /* inc delay line ptr */
    AR = I5;
    DM(I2, M1) = AR;                        /* save back to param array */
    M5 = -1;
    modify(I5, M5);                         /* move ptr back for actual calc */
    
    AR = DM(I2, M1);
    CNTR = AR;
    MR = 0;
    MX0=DM(I2,M1), MY0=PM(I5,M7);
    do ET1 until CE;
ET1:  MR=MR+MX0*MY0(SS), MX0=DM(I2,M1), MY0=PM(I5,M7);

    MR = MR + MX0 * MY0 (SS);
    if MV sat MR;

    I5 = SI;
    PM(I5, M6) = MR1;
    DM(I7, M6) = MR1;
    DM(p_DelaySynthGen) = I2;
    
    L5 = 0;

    rts;

.ENDMOD;    
    
