/******************************************************************************
*
*  HPWTGen2.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
******************************************************************************/

.MODULE                                     modHPWTGen2;


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      HPWTGen2;

HPWTGen2:
    I2 = DM(p_HPWTGen2);
    MX0 = DM(I2, M1);                       /* get msw freq */
    MX1 = DM(I2, M1);                       /* get lsw freq */
    dis AR_SAT, ena M_MODE;
    MY0 = 0x7ae0;
    MR = MX1 * MY0 (UU);                    /* mult lsw */
    MR0 = MR1;
    MR1 = MR2;                              /* rightshift by 16 */
    MR=MR+MX0*MY0(SU), AY1=MX1;             /* mult msw */
    AR=MR0+AY1, AY0=MX0;
    MR0=AR, AR=MR1+AY0+C;
    AY0 = DM(I2, M1);
    AY1 = DM(I2, M0);
        
    MR1=AR, AR=MR0+AY1;
    M2 = -1;
    modify(I2, M2);
    MX0=AR, AR=MR1+AY0+C;
    DM(I2, M1) = AR;                        /* msw newphase */
    
    MY0 = 128; 
    DM(I2,M1)=MX0, MR=MX0*MY0 (US);         /* write lsw newphase */
    MR0 = MR1;                              /* rightshift by 16 */
    MR1 = MR2;

    MR=MR+AR*MY0(US), AY0=DM(I2,M1);        /* get LUT base, calc LUT offset */
    AR = MR1 + AY0;
    I3 = AR;

    AY0 = DM(I3, M1);                       /* LUT(n) */
    AX0 = DM(I3, M1);                       /* LUT(n+1) */
    MY0=MR0, AR=AX0-AY0;                    /* get difference */

    MR = AR * MY0 (SU);                    /* scale to interpolate */
    
    ena AR_SAT, dis M_MODE;
    
    AR = MR1 + AY0;                         /* AR = interpolated output */
    DM(I7, M6) = AR;
    
    DM(p_HPWTGen2) = I2;
    
    rts;

.ENDMOD;