/******************************************************************************
*
*  LFO3.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modLFO3;

/*
 *  entry points
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

.ENTRY      LFO3;

LFO3:
    I2 = DM(p_LFO3);
    
    /* code added to handle S/H operation */
    AY0 = DM(I2, M1);                       /* holdperiod */
    AR = DM(I2, M0);                        /* currcount */
    NONE = AR - AY0;
    if GE jump NewLFOVal;
    M2 = 7;
    AR = AR + 1;
    DM(I2, M2) = AR;
    DM(p_LFO3) = I2;
    rts;
    
NewLFOVal:
    DM(I2, M1) = 1;                         /* reset currcount */

    /* end code added to handle S/H operation */

    MR1 = DM(I2, M1);                       /* get freq/phase */
    dis AR_SAT, ena M_MODE;
    MY0 = 0x7ae0;
    MR=MR+MR1*MY0 (UU), AY0=DM(I2, M0);     /* get oldphase */
    AR = MR1 + AY0;                         /* inc phase */
    MY0 = 128;
    DM(I2,M1)=AR, MR=AR*MY0 (UU);           /* writeback ph, get LUT offset */

    AY0 = DM(I2, M1);                       /* base of LUT */
    AR = MR1 + AY0;
    I3 = AR;

    AY0 = DM(I3, M1);                       /* LUT(n) */
    AX0 = DM(I3, M1);                       /* LUT(n+1) */
    MY0=MR0, AR=AX0-AY0;                    /* get difference */

    MR = AR * MY0 (SU);                     /* scale to interpolate */
    
    ena AR_SAT, dis M_MODE;
    
    AR=MR1+AY0, MY0=DM(I2, M1);             /* AR = interpolated output */

    MR=AR*MY0(ss), AY0=DM(I2,M1);           /* MR1=scaled LFO, get base */
    AR=MR1+AY0, AY0=DM(I2,M1);              /* AR=base+LFO, get mem ptr */
    I3 = AY0;
    DM(I3, M0) = AR;
    
    DM(p_LFO3) = I2;
    
    rts;

.ENDMOD;