/******************************************************************************
*
*  PrevCurrFilt.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modPrevCurrFilt;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  external variables and functions
 */
 
.ENTRY      PrevCurrFiltFX;

PrevCurrFiltFX:
    I2 = DM(p_PrevCurrFiltFX);
    AR = DM(I2, M1);                        /* get JT offset */
    AY0 = ^PCF_JT;
    AR = AR + AY0;
    I5 = AR;
    jump (I5);
    
PCF_JT:
    jump PrevCurrFilt0;
    jump PrevCurrFilt1;
    
PrevCurrFilt0:
    MY0 = DM(I2, M1);                       /* get max difference */
    AY0 = DM(I2, M0);                       /* get prev output */
    AX0 = DM(I7, M6);                       /* get data from output array */
    
    AF = pass -1;                           /* init AF to neg value */
    
    dis AR_SAT;
    AR = AX0 - AY0;
    ena AR_SAT;
    if GT AF = pass 1;                      /* check if diff is +/- */
    AR = abs AR;                            /* calc absolute diff */
    
    MR = AR * MY0 (uu);

    AX0 = AY0;
    AY0 = MR1;

    NONE = pass AF;
    if GT jump AddSamps;
    
SubSamps:
    AR = AX0 - AY0;
    jump WriteOutput;
    
AddSamps:
    AR = AX0 + AY0;
    
WriteOutput:
    DM(I7, M6) = AR;
    DM(I2, M1) = AR;                        /* update param list */
    DM(p_PrevCurrFiltFX) = I2;
    
    rts;


/* 
 *  read previous and current samples
 *  calc abs(curr-prev)
 *  if less than MDF param, don't change anything, else
 *    if curr-prev is neg, 
 */

PrevCurrFilt1:
    AY1 = DM(I2, M1);                       /* get max difference */
    AY0 = DM(I2, M0);                       /* get prev output */
    AX0 = DM(I7, M6);                       /* get data from output array */
    
    AF = pass -1;                           /* init AF to neg value */
    
    dis AR_SAT;
    AR = AX0 - AY0;                         /* curr - prev */
    ena AR_SAT;
    if GT AF = pass 1;                      /* check if diff is +/- */

    AR = abs AR;
    NONE = AR - AY1;                        /* diff - MDF */
    if LT jump SmallDiff;
    
    NONE = pass AF;
    if GT jump PosDiff;

NegDiff:
    AX0 = AY0;
    AR = AX0 - AY1;
    DM(I2, M1) = AR;
    DM(I7, M6) = AR;
    DM(p_PrevCurrFiltFX) = I2;
    rts;

PosDiff:
    AX0 = AY0;
    AR = AX0 + AY1;
    DM(I2, M1) = AR;
    DM(I7, M6) = AR;
    DM(p_PrevCurrFiltFX) = I2;
    rts;
    
SmallDiff:
    DM(I2, M1) = AX0;
    DM(p_PrevCurrFiltFX) = I2;
    rts;

.ENDMOD;