/*****************************************************************************
*
*  RotSynth.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
*****************************************************************************/

.MODULE                                     modRotSynth;

/*
 *  include files
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      RotSynthGen;

RotSynthGen:
    I2 = DM(p_RotSynthGen);
    AY0 = DM(I2, M1);                       /* rot freq */
    AR = DM(I2, M0);                        /* current count */
    AR = AR + 1;
    DM(I2, M0) = AR;                        /* update current count */
    NONE = AR - AY0;
    if GT jump CalcNewOutput;

HoldOutOutput:    
    modify(I2, M1);
    modify(I2, M1);
    AR = DM(I2, M1);                        /* get current output (0x1234) */
    DM(I7, M6) = AR;                        /* write old output */
    DM(p_RotSynthGen) = I2;
    rts;
    
CalcNewOutput:
    DM(I2, M1) = 0;                         /* reset counter */
    SE = DM(I2, M1);
    AR = DM(I2, M0);                        /* get current output (0x1234) */
    SR1 = 0;
    SR = lshift AR (LO);
    AY0 = SR1;
    AR = SR0 or AY0;
    DM(I2, M1) = AR;
    DM(p_RotSynthGen) = I2;
    
    DM(I7, M6) = AR;
    
    rts;

.ENDMOD;
    