/******************************************************************************
*
*  WTGenSync.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*
******************************************************************************/

.MODULE                                     modWTGenSyncFX;


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"

/*
 *  entry points
 */

.ENTRY      WTGenSyncFX;

WTGenSyncFX:
    I2 = DM(p_WTGenSyncFX);
    AY0 = DM(I2, M1);                   /* get base of WT params */
    AX0 = ^a_WTGen2;
    AR=AX0-AY0, MY0=DM(I2,M1);          /* Gen or Gen2, get oscnum0 */
    if NE jump WTGenSyncWTGen;

WTGenSyncWTGen2:
    MX0 = WTGEN2_VARS;
    MR = MX0 * MY0 (SS);
    SR = ashift MR0 by -1 (LO);
    AR = SR0 + AY0;                     /* AR = base of WT to sync */
    AY1 = WTGEN2_PHASE;
    AR=AR+AY1, MY0=DM(I2,M1);           /* get oscnum1 */
    I5 = AR;                            /* I5 = addr to reset */
    
    MR = MX0 * MY0 (SS);                /* MX0 = WTGEN2_VARS */
    SR = ashift MR0 by -1 (LO);
    AR = SR0 + AY0;                     /* AR = base of WT to sync */
    AR=AR+AY1, AX0=DM(I2,M0);           /* AY1 = WTGEN2_PHASE, get oldphase */
    I3 = AR;
    AF=pass AX0, AR=DM(I3,M0);          /* get phase of osc0 */
    if GE jump ExitWTGenSync2;
    AR = pass AR;                       /* test phase of osc0 */
    if LT jump ExitWTGenSync2;
    DM(I5, M6) = 0;                     /* sync osc */
    
ExitWTGenSync2:
    DM(I2, M1) = AR;
    DM(p_WTGenSyncFX) = I2;
    rts;

WTGenSyncWTGen:
    MX0 = WTGEN_VARS;
    MR = MX0 * MY0 (SS);
    SR = ashift MR0 by -1 (LO);
    AR = SR0 + AY0;                     /* AR = base of WT to sync */
    AY1 = WTGEN_PHASE;
    AR=AR+AY1, MY0=DM(I2,M1);           /* get oscnum1 */
    I5 = AR;                            /* I5 = addr to reset */
    
    MR = MX0 * MY0 (SS);                /* MX0 = WTGEN_VARS */
    SR = ashift MR0 by -1 (LO);
    AR = SR0 + AY0;                     /* AR = base of WT to sync */
    AR=AR+AY1, AX0=DM(I2,M0);           /* AY1 = WTGEN_PHASE, get oldphase */
    I3 = AR;
    AF=pass AX0, AR=DM(I3,M0);          /* get phase of osc0 */
    if GE jump ExitWTGenSync;
    AR = pass AR;                       /* test phase of osc0 */
    if LT jump ExitWTGenSync;
    DM(I5, M6) = 0;                     /* sync osc */
    
ExitWTGenSync:
    DM(I2, M1) = AR;
    DM(p_WTGenSyncFX) = I2;
    rts;

.ENDMOD;
