/******************************************************************************
*
*  gmInitMOE.dsp
*  
*  generative music initializing routine
*
******************************************************************************/

.MODULE                                     modInitMOE_29;

/*
 *  include files for all functions
 */
 

#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "new29.h"

/*
 *  external variables and functions
 */


/*
 *  entry points
 */

.ENTRY      InitGMParams_29;
.ENTRY      EndInitGMParams_29;

InitGMParams_29:
    SETPTR(a_WTGen);
    INIT_WTGEN(0, ^a_WTSine);
    INIT_WTGEN(0, ^a_WTSine);
    
    SETPTR(a_WTGen2);
    INIT_WTGEN2(60, ^a_WTTri);
    INIT_WTGEN2(61, ^a_WTTri);

    SETPTR(a_RotSynthGen);
    INIT_ROTSYNTHGEN(15, 1, 0x61cd);
    INIT_ROTSYNTHGEN(15, 1, 0x2831);
    INIT_ROTSYNTHGEN(10, 1, 0x187a);
    INIT_ROTSYNTHGEN(10, 1, 0x9751);
    INIT_ROTSYNTHGEN(10, 1, 0x3691);
    INIT_ROTSYNTHGEN(10, 1, 0xba7c);

    SETPTR(a_KSGen);
    INIT_KSGEN(0x0001, ^a_KSBuff1, 0x007f, 0x0000, 0x5208);
    INIT_KSGEN(0x0000, ^a_KSBuff2, 0x005f, 0x0000, 0x5408);
    INIT_KSGEN(0x0001, ^a_KSBuff3, 0x01ff, 0xfe00, 0x5208);
    INIT_KSGEN(0x0001, ^a_KSBuff4, 0x005f, 0x0800, 0x5208);
    INIT_KSGEN(0x0000, ^a_KSBuff5, 0x01ff, 0xc000, 0x4008);
    INIT_KSGEN(0x0000, ^a_KSBuff6, 0x01ff, 0xc000, 0x4008);
        
    SETPTR(a_WaveShapeFX);
    INIT_WAVESHAPEFX(WAVESHAPEFX_CONTINUOUS, 0x6000, 1, 0x4000, 0, 0x8000);
    INIT_WAVESHAPEFX(WAVESHAPEFX_CONTINUOUS, 0x6000, 1, 0x4000, 0, 0x8000);
    
    SETPTR(a_MemEnv3);
    INIT_MEMENV3(^a_WTGen+(0*WTGEN_VARS)+WTGEN_FREQ, 135, 135, 1, -30, (BASEPER_29*2)-1);
    INIT_MEMENV3(^a_WTGen+(1*WTGEN_VARS)+WTGEN_FREQ, 115, 115, 1, -60, (BASEPER_29*2)-1);
    
    
    !INIT_MEMENV3(^a_LFO3+(0*LFO3_VARS)+LFO3_FREQ, 60, 60, 7000, 60, 1);
    !INIT_MEMENV3(^a_LFO3+(1*LFO3_VARS)+LFO3_FREQ, 61, 61, 7000, 60, 1);
    
    SETPTR(a_LFO3);
    INIT_LFO3(0, 17, ^a_WTSine, 10, 66, ^a_WTGen2+(0*WTGEN2_VARS)+WTGEN2_FREQ);
    INIT_LFO3(0, 18, ^a_WTSine, 11, 67, ^a_WTGen2+(1*WTGEN2_VARS)+WTGEN2_FREQ);
    INIT_LFO3(3, 16, ^a_WTSq, 5, 15, ^a_RotSynthGen+(0*ROTSYNTHGEN_VARS)+ROTSYNTHGEN_COUNT);
    INIT_LFO3(3, 16, ^a_WTSq, 5, 15, ^a_RotSynthGen+(1*ROTSYNTHGEN_VARS)+ROTSYNTHGEN_COUNT);
    INIT_LFO3(3, 16, ^a_WTSq, 5, 25, ^a_RotSynthGen+(2*ROTSYNTHGEN_VARS)+ROTSYNTHGEN_COUNT);
    INIT_LFO3(3, 16, ^a_WTSq, 5, 25, ^a_RotSynthGen+(3*ROTSYNTHGEN_VARS)+ROTSYNTHGEN_COUNT);
    INIT_LFO3(2, 16, ^a_WTSq, 10, 30, ^a_RotSynthGen+(4*ROTSYNTHGEN_VARS)+ROTSYNTHGEN_COUNT);
    INIT_LFO3(2, 16, ^a_WTSq, 10, 30, ^a_RotSynthGen+(5*ROTSYNTHGEN_VARS)+ROTSYNTHGEN_COUNT);
        
    SETPTR(a_OscCombGen);
    INIT_OSCCOMBGEN(OSCCOMBGEN_MULT, 0, 1);
    INIT_OSCCOMBGEN(OSCCOMBGEN_MULT, 1, 2);
    INIT_OSCCOMBGEN(OSCCOMBGEN_XOR, 0, 0);

    SETPTR(a_ADSRPanEnv);
    ! bass triangles, osccombed triangles
    INIT_ADSRPANENV(0x7ffe, 0x7fff, 0x0000, 0x0000, 0x0000, 0x0000, 0x4000);
    INIT_ADSRPANENV(0x7ffe, 0x7fff, 0x0000, 0x0000, 0x0000, 0x0000, 0x4000);
    INIT_ADSRPANENV(0x7ffe, 0x7fff, 0x0000, 0x0000, 0x0000, 0x0000, 0x4000);
    INIT_ADSRPANENV(0x7ffe, 0x7fff, 0x0000, 0x0000, 0x0000, 0x0000, 0x4000);
    ! rapidfire nontriggered ksgen
    INIT_ADSRPANENV(0x7ffe, 0x7fff, 0x0000, 0x0000, 0x0000, 0x0000, 0x4000);
    INIT_ADSRPANENV(0x7ffe, 0x7fff, 0x0000, 0x0000, 0x0000, 0x0000, 0x4000);
    ! rotsynths
    INIT_ADSRPANENV(128, 0x4000, 0x0040, 0x0000, 0x2000, 0x0000, 0x4000);
    INIT_ADSRPANENV(128, 0x4000, 0x0040, 0x0000, 0x2000, 0x0000, 0x4000);
    ! osccomb4
    INIT_ADSRPANENV(128, 0x4000, 0x0800, 0x0200, 0x2000, 0x0000, 0x4000);
    ! rotsynths
    INIT_ADSRPANENV(128, 0x4000, 0x0040, 0x0000, 0x2000, 0x0000, 0x4000);
    INIT_ADSRPANENV(128, 0x4000, 0x0040, 0x0000, 0x2000, 0x0000, 0x4000);
    INIT_ADSRPANENV(128, 0x4000, 0x0040, 0x0000, 0x2000, 0x0000, 0x4000);
    INIT_ADSRPANENV(128, 0x4000, 0x0040, 0x0000, 0x2000, 0x0000, 0x4000);

    SETPTR(a_ExpDecayEnv);
    INIT_EXPDECAYENV(16, 0x7fe0, 0x4000);               ! bd1
    INIT_EXPDECAYENV(16, 0x7fe0, 0x4000);               ! ks1
    INIT_EXPDECAYENV(16, 0x7fe0, 0x4000);               ! bd2
    INIT_EXPDECAYENV(128, 0x7fe0, 0x4000);              ! ks2
    INIT_EXPDECAYENV(128, 0x7fe0, 0x2000);              ! ks5
    INIT_EXPDECAYENV(128, 0x7fe0, 0x6000);              ! ks6
    
    SETPTR(a_GenSHFX);
    INIT_GENSHFX(6);
    INIT_GENSHFX(3);
    INIT_GENSHFX(7);
    INIT_GENSHFX(10);
        
    AR = 128;
    DM(v_FABCNTR_29) = AR;
    DM(v_SongCNTR_29) = M0;
    DM(v_DelayCNTR) = M0;
        
    AY0 = OSCCOMBPERIOD_29;
    DM(v_ModOscComb_29) = AY0;
    DM(v_ModOscCombPeriod_29) = AY0;
    DM(v_ProbModOC2_29) = M0;
    AY0 = 0x3f;
    DM(v_KSMask1_29) = AY0;
    AY0 = 0x3f;
    DM(v_KSMask2_29) = AY0;
    AY0 = KSPERIOD3_29;
    DM(v_TrigKS3_29) = AY0;
    DM(v_KSPeriod3_29) = AY0;
    AY0 = 0x3f;
    DM(v_KSMask3_29) = AY0;
    DM(v_KS3Count_29) = M0;
    AY0 = KSPERIOD4_29;
    DM(v_TrigKS4_29) = AY0;
    DM(v_KSPeriod4_29) = AY0;
    AY0 = 0xf;
    DM(v_KSMask4_29) = AY0;
    DM(v_KS4Count_29) = M0;

    AX1 = 0x0c00;
    DM(v_BaseScalarKS3_29) = AX1;
    AX1 = 0x0a00;
    DM(v_BaseScalarKS4_29) = AX1;

/*
 *  autogenerated code for SETTRACK macro
 */
    I2 = ^a_TrigTrack00;
    I3 = ^a_VolTrack00;
    CNTR = 128;
    do CL00148 until CE;
        DM(I2, M1) = 0;
CL00148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack01;
    I3 = ^a_VolTrack01;
    CNTR = 128;
    do CL01148 until CE;
        DM(I2, M1) = 0;
CL01148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack02;
    I3 = ^a_VolTrack02;
    CNTR = 128;
    do CL02148 until CE;
        DM(I2, M1) = 0;
CL02148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack03;
    I3 = ^a_VolTrack03;
    CNTR = 128;
    do CL03148 until CE;
        DM(I2, M1) = 0;
CL03148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack04;
    I3 = ^a_VolTrack04;
    CNTR = 128;
    do CL04148 until CE;
        DM(I2, M1) = 0;
CL04148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack05;
    I3 = ^a_VolTrack05;
    CNTR = 128;
    do CL05148 until CE;
        DM(I2, M1) = 0;
CL05148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack06;
    I3 = ^a_VolTrack06;
    CNTR = 128;
    do CL06148 until CE;
        DM(I2, M1) = 0;
CL06148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack07;
    I3 = ^a_VolTrack07;
    CNTR = 128;
    do CL07148 until CE;
        DM(I2, M1) = 0;
CL07148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack10;
    I3 = ^a_VolTrack10;
    CNTR = 128;
    do CL10148 until CE;
        DM(I2, M1) = 0;
CL10148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack11;
    I3 = ^a_VolTrack11;
    CNTR = 128;
    do CL11148 until CE;
        DM(I2, M1) = 0;
CL11148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack12;
    I3 = ^a_VolTrack12;
    CNTR = 128;
    do CL12148 until CE;
        DM(I2, M1) = 0;
CL12148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack13;
    I3 = ^a_VolTrack13;
    CNTR = 128;
    do CL13148 until CE;
        DM(I2, M1) = 0;
CL13148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack14;
    I3 = ^a_VolTrack14;
    CNTR = 128;
    do CL14148 until CE;
        DM(I2, M1) = 0;
CL14148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack15;
    I3 = ^a_VolTrack15;
    CNTR = 128;
    do CL15148 until CE;
        DM(I2, M1) = 0;
CL15148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack16;
    I3 = ^a_VolTrack16;
    CNTR = 128;
    do CL16148 until CE;
        DM(I2, M1) = 0;
CL16148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack17;
    I3 = ^a_VolTrack17;
    CNTR = 128;
    do CL17148 until CE;
        DM(I2, M1) = 0;
CL17148:   DM(I3, M1) = 0;

    I2 = ^a_TrigTrack18;
    I3 = ^a_VolTrack18;
    CNTR = 128;
    do CL18148 until CE;
        DM(I2, M1) = 0;
CL18148:   DM(I3, M1) = 0;

    /* inits for a */
    AX0 = 100;
    AX1 = 0x0600;
    DM(a_TrigTrack00+0+0) = AX0;
    DM(a_VolTrack00+0+0) = AX1;
    DM(a_TrigTrack01+0+0) = AX0;
    DM(a_VolTrack01+0+0) = AX1;

    /* inits for b */
    AX0 = 100;
    AX1 = 0x0d00;
    DM(a_TrigTrack03+0+0) = AX0;
    DM(a_VolTrack03+0+0) = AX1;

    /* inits for c */
    AX0 = 100;
    AX1 = 0x3400;
    DM(a_TrigTrack04+0+0) = AX0;
    DM(a_VolTrack04+0+0) = AX1;
    DM(a_TrigTrack04+0+8) = AX0;
    DM(a_VolTrack04+0+8) = AX1;
    DM(a_TrigTrack04+0+16) = AX0;
    DM(a_VolTrack04+0+16) = AX1;
    DM(a_TrigTrack04+0+24) = AX0;
    DM(a_VolTrack04+0+24) = AX1;
    DM(a_TrigTrack04+0+32) = AX0;
    DM(a_VolTrack04+0+32) = AX1;
    DM(a_TrigTrack05+0+32) = AX0;
    DM(a_VolTrack05+0+32) = AX1;
    DM(a_TrigTrack04+0+40) = AX0;
    DM(a_VolTrack04+0+40) = AX1;
    DM(a_TrigTrack05+0+40) = AX0;
    DM(a_VolTrack05+0+40) = AX1;
    DM(a_TrigTrack04+0+48) = AX0;
    DM(a_VolTrack04+0+48) = AX1;
    DM(a_TrigTrack05+0+48) = AX0;
    DM(a_VolTrack05+0+48) = AX1;
    DM(a_TrigTrack04+0+56) = AX0;
    DM(a_VolTrack04+0+56) = AX1;
    DM(a_TrigTrack05+0+56) = AX0;
    DM(a_VolTrack05+0+56) = AX1;

    /* inits for d */
    AX0 = 100;
    AX1 = 0x3000;
    DM(a_TrigTrack05+0+8) = AX0;
    DM(a_VolTrack05+0+8) = AX1;

    /* inits for e */
    AX0 = 100;
    AX1 = 0x0c00;
    DM(a_TrigTrack05+0+12) = AX0;
    DM(a_VolTrack05+0+12) = AX1;
    DM(a_TrigTrack05+0+20) = AX0;
    DM(a_VolTrack05+0+20) = AX1;

    /* inits for f */
    AX0 = 100;
    AX1 = 0x1200;
    DM(a_TrigTrack05+0+16) = AX0;
    DM(a_VolTrack05+0+16) = AX1;

    /* inits for g */
    AX0 = 100;
    AX1 = 0x4800;
    DM(a_TrigTrack05+0+24) = AX0;
    DM(a_VolTrack05+0+24) = AX1;

    /* inits for h */
    AX0 = 100;
    AX1 = 0x2000;
    DM(a_TrigTrack06+0+4) = AX0;
    DM(a_VolTrack06+0+4) = AX1;
    DM(a_TrigTrack06+0+8) = AX0;
    DM(a_VolTrack06+0+8) = AX1;
    DM(a_TrigTrack06+0+24) = AX0;
    DM(a_VolTrack06+0+24) = AX1;
    DM(a_TrigTrack06+0+40) = AX0;
    DM(a_VolTrack06+0+40) = AX1;
    DM(a_TrigTrack07+0+40) = AX0;
    DM(a_VolTrack07+0+40) = AX1;
    DM(a_TrigTrack06+0+56) = AX0;
    DM(a_VolTrack06+0+56) = AX1;
    DM(a_TrigTrack07+0+56) = AX0;
    DM(a_VolTrack07+0+56) = AX1;

    /* inits for i */
    AX0 = 50;
    AX1 = 0x2800;
    DM(a_TrigTrack06+0+14) = AX0;
    DM(a_VolTrack06+0+14) = AX1;
    DM(a_TrigTrack06+0+20) = AX0;
    DM(a_VolTrack06+0+20) = AX1;
    DM(a_TrigTrack06+0+46) = AX0;
    DM(a_VolTrack06+0+46) = AX1;
    DM(a_TrigTrack07+0+46) = AX0;
    DM(a_VolTrack07+0+46) = AX1;

    /* inits for j */
    AX0 = 100;
    AX1 = 0x2800;
    DM(a_TrigTrack07+0+0) = AX0;
    DM(a_VolTrack07+0+0) = AX1;
    DM(a_TrigTrack07+0+8) = AX0;
    DM(a_VolTrack07+0+8) = AX1;
    DM(a_TrigTrack07+0+16) = AX0;
    DM(a_VolTrack07+0+16) = AX1;
    DM(a_TrigTrack07+0+24) = AX0;
    DM(a_VolTrack07+0+24) = AX1;
    DM(a_TrigTrack06+0+36) = AX0;
    DM(a_VolTrack06+0+36) = AX1;
    DM(a_TrigTrack07+0+36) = AX0;
    DM(a_VolTrack07+0+36) = AX1;
    DM(a_TrigTrack06+0+52) = AX0;
    DM(a_VolTrack06+0+52) = AX1;
    DM(a_TrigTrack07+0+52) = AX0;
    DM(a_VolTrack07+0+52) = AX1;

    /* inits for k */
    AX0 = 100;
    AX1 = 0x1200;
    DM(a_TrigTrack07+0+4) = AX0;
    DM(a_VolTrack07+0+4) = AX1;
    DM(a_TrigTrack07+0+20) = AX0;
    DM(a_VolTrack07+0+20) = AX1;

    /* inits for l */
    AX0 = 50;
    AX1 = 0x0c00;
    DM(a_TrigTrack07+0+2) = AX0;
    DM(a_VolTrack07+0+2) = AX1;
    DM(a_TrigTrack07+0+22) = AX0;
    DM(a_VolTrack07+0+22) = AX1;
    DM(a_TrigTrack07+0+28) = AX0;
    DM(a_VolTrack07+0+28) = AX1;
    DM(a_TrigTrack05+0+30) = AX0;
    DM(a_VolTrack05+0+30) = AX1;
    DM(a_TrigTrack05+0+31) = AX0;
    DM(a_VolTrack05+0+31) = AX1;

    /* inits for m */
    AX0 = 100;
    AX1 = 0x0700;
    DM(a_TrigTrack10+0+0) = AX0;
    DM(a_VolTrack10+0+0) = AX1;
    DM(a_TrigTrack11+0+0) = AX0;
    DM(a_VolTrack11+0+0) = AX1;
    DM(a_TrigTrack13+0+0) = AX0;
    DM(a_VolTrack13+0+0) = AX1;
    DM(a_TrigTrack14+0+0) = AX0;
    DM(a_VolTrack14+0+0) = AX1;
    DM(a_TrigTrack15+0+0) = AX0;
    DM(a_VolTrack15+0+0) = AX1;
    DM(a_TrigTrack16+0+0) = AX0;
    DM(a_VolTrack16+0+0) = AX1;
    DM(a_TrigTrack10+0+6) = AX0;
    DM(a_VolTrack10+0+6) = AX1;
    DM(a_TrigTrack11+0+6) = AX0;
    DM(a_VolTrack11+0+6) = AX1;
    DM(a_TrigTrack13+0+6) = AX0;
    DM(a_VolTrack13+0+6) = AX1;
    DM(a_TrigTrack14+0+6) = AX0;
    DM(a_VolTrack14+0+6) = AX1;
    DM(a_TrigTrack15+0+6) = AX0;
    DM(a_VolTrack15+0+6) = AX1;
    DM(a_TrigTrack16+0+6) = AX0;
    DM(a_VolTrack16+0+6) = AX1;
    DM(a_TrigTrack10+0+12) = AX0;
    DM(a_VolTrack10+0+12) = AX1;
    DM(a_TrigTrack11+0+12) = AX0;
    DM(a_VolTrack11+0+12) = AX1;
    DM(a_TrigTrack13+0+12) = AX0;
    DM(a_VolTrack13+0+12) = AX1;
    DM(a_TrigTrack14+0+12) = AX0;
    DM(a_VolTrack14+0+12) = AX1;
    DM(a_TrigTrack15+0+12) = AX0;
    DM(a_VolTrack15+0+12) = AX1;
    DM(a_TrigTrack16+0+12) = AX0;
    DM(a_VolTrack16+0+12) = AX1;
    DM(a_TrigTrack10+0+16) = AX0;
    DM(a_VolTrack10+0+16) = AX1;
    DM(a_TrigTrack11+0+16) = AX0;
    DM(a_VolTrack11+0+16) = AX1;
    DM(a_TrigTrack13+0+16) = AX0;
    DM(a_VolTrack13+0+16) = AX1;
    DM(a_TrigTrack14+0+16) = AX0;
    DM(a_VolTrack14+0+16) = AX1;
    DM(a_TrigTrack15+0+16) = AX0;
    DM(a_VolTrack15+0+16) = AX1;
    DM(a_TrigTrack16+0+16) = AX0;
    DM(a_VolTrack16+0+16) = AX1;
    DM(a_TrigTrack10+0+22) = AX0;
    DM(a_VolTrack10+0+22) = AX1;
    DM(a_TrigTrack11+0+22) = AX0;
    DM(a_VolTrack11+0+22) = AX1;
    DM(a_TrigTrack13+0+22) = AX0;
    DM(a_VolTrack13+0+22) = AX1;
    DM(a_TrigTrack14+0+22) = AX0;
    DM(a_VolTrack14+0+22) = AX1;
    DM(a_TrigTrack15+0+22) = AX0;
    DM(a_VolTrack15+0+22) = AX1;
    DM(a_TrigTrack16+0+22) = AX0;
    DM(a_VolTrack16+0+22) = AX1;
    DM(a_TrigTrack10+0+28) = AX0;
    DM(a_VolTrack10+0+28) = AX1;
    DM(a_TrigTrack11+0+28) = AX0;
    DM(a_VolTrack11+0+28) = AX1;
    DM(a_TrigTrack13+0+28) = AX0;
    DM(a_VolTrack13+0+28) = AX1;
    DM(a_TrigTrack14+0+28) = AX0;
    DM(a_VolTrack14+0+28) = AX1;
    DM(a_TrigTrack15+0+28) = AX0;
    DM(a_VolTrack15+0+28) = AX1;
    DM(a_TrigTrack16+0+28) = AX0;
    DM(a_VolTrack16+0+28) = AX1;
    DM(a_TrigTrack10+0+32) = AX0;
    DM(a_VolTrack10+0+32) = AX1;
    DM(a_TrigTrack11+0+32) = AX0;
    DM(a_VolTrack11+0+32) = AX1;
    DM(a_TrigTrack13+0+32) = AX0;
    DM(a_VolTrack13+0+32) = AX1;
    DM(a_TrigTrack14+0+32) = AX0;
    DM(a_VolTrack14+0+32) = AX1;
    DM(a_TrigTrack15+0+32) = AX0;
    DM(a_VolTrack15+0+32) = AX1;
    DM(a_TrigTrack16+0+32) = AX0;
    DM(a_VolTrack16+0+32) = AX1;
    DM(a_TrigTrack10+0+38) = AX0;
    DM(a_VolTrack10+0+38) = AX1;
    DM(a_TrigTrack11+0+38) = AX0;
    DM(a_VolTrack11+0+38) = AX1;
    DM(a_TrigTrack13+0+38) = AX0;
    DM(a_VolTrack13+0+38) = AX1;
    DM(a_TrigTrack14+0+38) = AX0;
    DM(a_VolTrack14+0+38) = AX1;
    DM(a_TrigTrack15+0+38) = AX0;
    DM(a_VolTrack15+0+38) = AX1;
    DM(a_TrigTrack16+0+38) = AX0;
    DM(a_VolTrack16+0+38) = AX1;
    DM(a_TrigTrack10+0+44) = AX0;
    DM(a_VolTrack10+0+44) = AX1;
    DM(a_TrigTrack11+0+44) = AX0;
    DM(a_VolTrack11+0+44) = AX1;
    DM(a_TrigTrack13+0+44) = AX0;
    DM(a_VolTrack13+0+44) = AX1;
    DM(a_TrigTrack14+0+44) = AX0;
    DM(a_VolTrack14+0+44) = AX1;
    DM(a_TrigTrack15+0+44) = AX0;
    DM(a_VolTrack15+0+44) = AX1;
    DM(a_TrigTrack16+0+44) = AX0;
    DM(a_VolTrack16+0+44) = AX1;
    DM(a_TrigTrack10+0+48) = AX0;
    DM(a_VolTrack10+0+48) = AX1;
    DM(a_TrigTrack11+0+48) = AX0;
    DM(a_VolTrack11+0+48) = AX1;
    DM(a_TrigTrack13+0+48) = AX0;
    DM(a_VolTrack13+0+48) = AX1;
    DM(a_TrigTrack14+0+48) = AX0;
    DM(a_VolTrack14+0+48) = AX1;
    DM(a_TrigTrack15+0+48) = AX0;
    DM(a_VolTrack15+0+48) = AX1;
    DM(a_TrigTrack16+0+48) = AX0;
    DM(a_VolTrack16+0+48) = AX1;
    DM(a_TrigTrack10+0+54) = AX0;
    DM(a_VolTrack10+0+54) = AX1;
    DM(a_TrigTrack11+0+54) = AX0;
    DM(a_VolTrack11+0+54) = AX1;
    DM(a_TrigTrack13+0+54) = AX0;
    DM(a_VolTrack13+0+54) = AX1;
    DM(a_TrigTrack14+0+54) = AX0;
    DM(a_VolTrack14+0+54) = AX1;
    DM(a_TrigTrack15+0+54) = AX0;
    DM(a_VolTrack15+0+54) = AX1;
    DM(a_TrigTrack16+0+54) = AX0;
    DM(a_VolTrack16+0+54) = AX1;
    DM(a_TrigTrack11+0+60) = AX0;
    DM(a_VolTrack11+0+60) = AX1;
    DM(a_TrigTrack14+0+60) = AX0;
    DM(a_VolTrack14+0+60) = AX1;
    DM(a_TrigTrack16+0+60) = AX0;
    DM(a_VolTrack16+0+60) = AX1;
    DM(a_TrigTrack10+0+62) = AX0;
    DM(a_VolTrack10+0+62) = AX1;
    DM(a_TrigTrack13+0+62) = AX0;
    DM(a_VolTrack13+0+62) = AX1;
    DM(a_TrigTrack15+0+62) = AX0;
    DM(a_VolTrack15+0+62) = AX1;

    /* inits for n */
    AX0 = 50;
    AX1 = 0x0900;
    DM(a_TrigTrack10+0+8) = AX0;
    DM(a_VolTrack10+0+8) = AX1;
    DM(a_TrigTrack13+0+8) = AX0;
    DM(a_VolTrack13+0+8) = AX1;
    DM(a_TrigTrack15+0+8) = AX0;
    DM(a_VolTrack15+0+8) = AX1;
    DM(a_TrigTrack10+0+20) = AX0;
    DM(a_VolTrack10+0+20) = AX1;
    DM(a_TrigTrack13+0+20) = AX0;
    DM(a_VolTrack13+0+20) = AX1;
    DM(a_TrigTrack15+0+20) = AX0;
    DM(a_VolTrack15+0+20) = AX1;
    DM(a_TrigTrack10+0+40) = AX0;
    DM(a_VolTrack10+0+40) = AX1;
    DM(a_TrigTrack13+0+40) = AX0;
    DM(a_VolTrack13+0+40) = AX1;
    DM(a_TrigTrack15+0+40) = AX0;
    DM(a_VolTrack15+0+40) = AX1;
    DM(a_TrigTrack10+0+52) = AX0;
    DM(a_VolTrack10+0+52) = AX1;
    DM(a_TrigTrack13+0+52) = AX0;
    DM(a_VolTrack13+0+52) = AX1;
    DM(a_TrigTrack15+0+52) = AX0;
    DM(a_VolTrack15+0+52) = AX1;

    /* inits for o */
    AX0 = 20;
    AX1 = 0x0800;
    DM(a_TrigTrack10+0+2) = AX0;
    DM(a_VolTrack10+0+2) = AX1;
    DM(a_TrigTrack13+0+2) = AX0;
    DM(a_VolTrack13+0+2) = AX1;
    DM(a_TrigTrack15+0+2) = AX0;
    DM(a_VolTrack15+0+2) = AX1;
    DM(a_TrigTrack10+0+29) = AX0;
    DM(a_VolTrack10+0+29) = AX1;
    DM(a_TrigTrack13+0+29) = AX0;
    DM(a_VolTrack13+0+29) = AX1;
    DM(a_TrigTrack15+0+29) = AX0;
    DM(a_VolTrack15+0+29) = AX1;
    DM(a_TrigTrack10+0+33) = AX0;
    DM(a_VolTrack10+0+33) = AX1;
    DM(a_TrigTrack13+0+33) = AX0;
    DM(a_VolTrack13+0+33) = AX1;
    DM(a_TrigTrack15+0+33) = AX0;
    DM(a_VolTrack15+0+33) = AX1;
    DM(a_TrigTrack10+0+63) = AX0;
    DM(a_VolTrack10+0+63) = AX1;
    DM(a_TrigTrack13+0+63) = AX0;
    DM(a_VolTrack13+0+63) = AX1;
    DM(a_TrigTrack15+0+63) = AX0;
    DM(a_VolTrack15+0+63) = AX1;

    /* inits for p */
    AX0 = 100;
    AX1 = 0x2000;
    DM(a_TrigTrack12+0+0) = AX0;
    DM(a_VolTrack12+0+0) = AX1;
    DM(a_TrigTrack12+0+2) = AX0;
    DM(a_VolTrack12+0+2) = AX1;
    DM(a_TrigTrack12+0+4) = AX0;
    DM(a_VolTrack12+0+4) = AX1;
    DM(a_TrigTrack12+0+6) = AX0;
    DM(a_VolTrack12+0+6) = AX1;
    DM(a_TrigTrack12+0+10) = AX0;
    DM(a_VolTrack12+0+10) = AX1;
    DM(a_TrigTrack12+0+14) = AX0;
    DM(a_VolTrack12+0+14) = AX1;
    DM(a_TrigTrack12+0+18) = AX0;
    DM(a_VolTrack12+0+18) = AX1;
    DM(a_TrigTrack12+0+22) = AX0;
    DM(a_VolTrack12+0+22) = AX1;
    DM(a_TrigTrack12+0+24) = AX0;
    DM(a_VolTrack12+0+24) = AX1;
    DM(a_TrigTrack12+0+26) = AX0;
    DM(a_VolTrack12+0+26) = AX1;
    DM(a_TrigTrack12+0+30) = AX0;
    DM(a_VolTrack12+0+30) = AX1;
    DM(a_TrigTrack12+0+32) = AX0;
    DM(a_VolTrack12+0+32) = AX1;
    DM(a_TrigTrack12+0+34) = AX0;
    DM(a_VolTrack12+0+34) = AX1;
    DM(a_TrigTrack12+0+36) = AX0;
    DM(a_VolTrack12+0+36) = AX1;
    DM(a_TrigTrack12+0+38) = AX0;
    DM(a_VolTrack12+0+38) = AX1;
    DM(a_TrigTrack12+0+42) = AX0;
    DM(a_VolTrack12+0+42) = AX1;
    DM(a_TrigTrack12+0+46) = AX0;
    DM(a_VolTrack12+0+46) = AX1;
    DM(a_TrigTrack12+0+50) = AX0;
    DM(a_VolTrack12+0+50) = AX1;
    DM(a_TrigTrack12+0+54) = AX0;
    DM(a_VolTrack12+0+54) = AX1;
    DM(a_TrigTrack12+0+56) = AX0;
    DM(a_VolTrack12+0+56) = AX1;
    DM(a_TrigTrack12+0+58) = AX0;
    DM(a_VolTrack12+0+58) = AX1;
    DM(a_TrigTrack12+0+60) = AX0;
    DM(a_VolTrack12+0+60) = AX1;
    DM(a_TrigTrack12+0+62) = AX0;
    DM(a_VolTrack12+0+62) = AX1;

    /* inits for q */
    AX0 = 50;
    AX1 = 0x1400;
    DM(a_TrigTrack12+0+12) = AX0;
    DM(a_VolTrack12+0+12) = AX1;
    DM(a_TrigTrack12+0+16) = AX0;
    DM(a_VolTrack12+0+16) = AX1;
    DM(a_TrigTrack12+0+40) = AX0;
    DM(a_VolTrack12+0+40) = AX1;
    DM(a_TrigTrack12+0+41) = AX0;
    DM(a_VolTrack12+0+41) = AX1;
    DM(a_TrigTrack12+0+51) = AX0;
    DM(a_VolTrack12+0+51) = AX1;
    DM(a_TrigTrack12+0+61) = AX0;
    DM(a_VolTrack12+0+61) = AX1;

    /* inits for r */
    AX0 = 100;
    AX1 = 0x1600;
    DM(a_TrigTrack02+0+0) = AX0;
    DM(a_VolTrack02+0+0) = AX1;

    /* inits for s */
    AX0 = 100;
    AX1 = 0x1a00;
    DM(a_TrigTrack17+0+0) = AX0;
    DM(a_VolTrack17+0+0) = AX1;
    DM(a_TrigTrack18+0+0) = AX0;
    DM(a_VolTrack18+0+0) = AX1;
    DM(a_TrigTrack17+0+8) = AX0;
    DM(a_VolTrack17+0+8) = AX1;
    DM(a_TrigTrack18+0+8) = AX0;
    DM(a_VolTrack18+0+8) = AX1;
    DM(a_TrigTrack17+0+16) = AX0;
    DM(a_VolTrack17+0+16) = AX1;
    DM(a_TrigTrack18+0+16) = AX0;
    DM(a_VolTrack18+0+16) = AX1;
    DM(a_TrigTrack17+0+24) = AX0;
    DM(a_VolTrack17+0+24) = AX1;
    DM(a_TrigTrack18+0+24) = AX0;
    DM(a_VolTrack18+0+24) = AX1;
    DM(a_TrigTrack17+0+32) = AX0;
    DM(a_VolTrack17+0+32) = AX1;
    DM(a_TrigTrack18+0+32) = AX0;
    DM(a_VolTrack18+0+32) = AX1;
    DM(a_TrigTrack17+0+40) = AX0;
    DM(a_VolTrack17+0+40) = AX1;
    DM(a_TrigTrack18+0+40) = AX0;
    DM(a_VolTrack18+0+40) = AX1;
    DM(a_TrigTrack17+0+48) = AX0;
    DM(a_VolTrack17+0+48) = AX1;
    DM(a_TrigTrack18+0+48) = AX0;
    DM(a_VolTrack18+0+48) = AX1;
    DM(a_TrigTrack17+0+56) = AX0;
    DM(a_VolTrack17+0+56) = AX1;
    DM(a_TrigTrack18+0+56) = AX0;
    DM(a_VolTrack18+0+56) = AX1;

    /* inits for t */
    AX0 = 100;
    AX1 = 0x0700;
    DM(a_TrigTrack17+0+12) = AX0;
    DM(a_VolTrack17+0+12) = AX1;
    DM(a_TrigTrack18+0+12) = AX0;
    DM(a_VolTrack18+0+12) = AX1;
    DM(a_TrigTrack17+0+13) = AX0;
    DM(a_VolTrack17+0+13) = AX1;
    DM(a_TrigTrack18+0+13) = AX0;
    DM(a_VolTrack18+0+13) = AX1;
    DM(a_TrigTrack17+0+14) = AX0;
    DM(a_VolTrack17+0+14) = AX1;
    DM(a_TrigTrack18+0+14) = AX0;
    DM(a_VolTrack18+0+14) = AX1;
    DM(a_TrigTrack17+0+15) = AX0;
    DM(a_VolTrack17+0+15) = AX1;
    DM(a_TrigTrack18+0+15) = AX0;
    DM(a_VolTrack18+0+15) = AX1;
    DM(a_TrigTrack17+0+28) = AX0;
    DM(a_VolTrack17+0+28) = AX1;
    DM(a_TrigTrack18+0+28) = AX0;
    DM(a_VolTrack18+0+28) = AX1;
    DM(a_TrigTrack17+0+33) = AX0;
    DM(a_VolTrack17+0+33) = AX1;
    DM(a_TrigTrack18+0+33) = AX0;
    DM(a_VolTrack18+0+33) = AX1;
    DM(a_TrigTrack17+0+34) = AX0;
    DM(a_VolTrack17+0+34) = AX1;
    DM(a_TrigTrack18+0+34) = AX0;
    DM(a_VolTrack18+0+34) = AX1;
    DM(a_TrigTrack17+0+35) = AX0;
    DM(a_VolTrack17+0+35) = AX1;
    DM(a_TrigTrack18+0+35) = AX0;
    DM(a_VolTrack18+0+35) = AX1;
    DM(a_TrigTrack17+0+36) = AX0;
    DM(a_VolTrack17+0+36) = AX1;
    DM(a_TrigTrack18+0+36) = AX0;
    DM(a_VolTrack18+0+36) = AX1;
    DM(a_TrigTrack17+0+42) = AX0;
    DM(a_VolTrack17+0+42) = AX1;
    DM(a_TrigTrack18+0+42) = AX0;
    DM(a_VolTrack18+0+42) = AX1;
    DM(a_TrigTrack17+0+46) = AX0;
    DM(a_VolTrack17+0+46) = AX1;
    DM(a_TrigTrack18+0+46) = AX0;
    DM(a_VolTrack18+0+46) = AX1;
    DM(a_TrigTrack18+0+58) = AX0;
    DM(a_VolTrack18+0+58) = AX1;
    DM(a_TrigTrack17+0+60) = AX0;
    DM(a_VolTrack17+0+60) = AX1;
    DM(a_TrigTrack17+0+62) = AX0;
    DM(a_VolTrack17+0+62) = AX1;
    DM(a_TrigTrack18+0+62) = AX0;
    DM(a_VolTrack18+0+62) = AX1;

/* donotparse(CLEAR, 0, 0,  a,
            CLEAR, 0, 1,  a,
            CLEAR, 0, 2,  r,
            CLEAR, 0, 3,  b,
            CLEAR, 0, 4,  c------- c-------  c------- c------- c------- c------- c------- c-------,
            CLEAR, 0, 5,  -------- d---e---  f---e--- g-----ll,
            CLEAR, 0, 6,  ----h--- h-----i-  ----i--- h------- ----j--- h-----i- ----j--- h-------,
            CLEAR, 0, 7,  j-l-k--- j-------  j---k-l- j---l---,
            CLEAR, 0, 10, m-o---m- n---m---  m---n-m- ----mo-- mo----m- n---m--- m---n-m- ------mo,
            CLEAR, 0, 11, m-----m- ----m---  m-----m- ----m--- m-----m- ----m--- m-----m- ----m---,
            CLEAR, 0, 12, p-p-p-p- --p-q-p-  q-p---p- p-p---p- p-p-p-p- qqp---p- --pq--p- p-p-pqp-,
            CLEAR, 0, 13, m-o---m- n---m---  m---n-m- ----mo-- mo----m- n---m--- m---n-m- ------mo,
            CLEAR, 0, 14, m-----m- ----m---  m-----m- ----m--- m-----m- ----m--- m-----m- ----m---,
            CLEAR, 0, 15, m-o---m- n---m---  m---n-m- ----mo-- mo----m- n---m--- m---n-m- ------mo,
            CLEAR, 0, 16, m-----m- ----m---  m-----m- ----m--- m-----m- ----m--- m-----m- ----m---,
            CLEAR, 0, 17, s------- s---tttt  s------- s---t--- stttt--- s-t---t- s------- s---t-t-,
            CLEAR, 0, 18, s------- s---tttt  s------- s---t--- stttt--- s-t---t- s------- s-t---t-,
            a, 100, 0x0600,
            b, 100, 0x0d00,
            c, 100, 0x3400,
            d, 100, 0x3000,
            e, 100, 0x0c00,
            f, 100, 0x1200,
            g, 100, 0x4800,
            h, 100, 0x2000,
            i, 50,  0x2800,
            j, 100, 0x2800,
            k, 100, 0x1200,
            l, 50,  0x0c00,
            m, 100, 0x0700,
            n, 50,  0x0900,
            o, 20,  0x0800,
            p, 100, 0x2000,
            q, 50,  0x1400,
            r, 100, 0x1600,
            s, 100, 0x1a00,
            t, 100, 0x0700,
            END); */

    SETPTR(a_Seq2);
    modify(I2, M1);                         /* numtrax set by CalcSeq2Tracks */
    ! triangle and osccomb on triangle
    INIT_SEQ2(10000, 0, 0, 64, ADSRENV);
    INIT_SEQ2(10000, 0, 0, 64, ADSRENV);
    INIT_SEQ2(10000, 0, 0, 64, ADSRENV);
    INIT_SEQ2(10000, 0, 0, 64, ADSRENV);
    ! main bd and triggered ks
    INIT_SEQ2(BDPERIOD1_29, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(KSPERIOD1_29, 0, 0, 32, EXPDECAYENV);
    INIT_SEQ2(BDPERIOD2_29, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(KSPERIOD2_29, 0, 0, 32, EXPDECAYENV);
    ! nontriggered ks
    INIT_SEQ2(10000, 0, 0, 64, ADSRENV);
    INIT_SEQ2(10000, 0, 0, 64, ADSRENV);
    ! rotsynths
    INIT_SEQ2(ROTPERIOD1_29, 0, 0, 64, ADSRENV);
    INIT_SEQ2(ROTPERIOD2_29, 0, 0, 64, ADSRENV);
    ! osccomb4
    INIT_SEQ2(OCPERIOD4_29, 0, 0, 64, ADSRENV);
    ! rotsynths
    INIT_SEQ2(ROTPERIOD3_29, 0, 0, 64, ADSRENV);
    INIT_SEQ2(ROTPERIOD4_29, 0, 0, 64, ADSRENV);
    INIT_SEQ2(ROTPERIOD5_29, 0, 0, 64, ADSRENV);
    INIT_SEQ2(ROTPERIOD6_29, 0, 0, 64, ADSRENV);
    ! wispy ks
    INIT_SEQ2(KSPERIOD5_29, 0, 0, 64, EXPDECAYENV);
    INIT_SEQ2(KSPERIOD6_29, 0, 0, 64, EXPDECAYENV);
    
              
    /* must be called after Seq2 init to set env and num tracks */
    call Seq2PostProc;
    
    SET_TICS_PER_MEASURE(BASEPER_29*32);

    AR = ^InitGMParams_29;
    AX0 = ^EndInitGMParams_29;
    call FillGenFXPtrInits;
    
    /* init ^Env and set length of array of ptrs used in GenFXPtrInits */
    call GenFXIniPostProc;                  /* do not remove! */

    
    MUTETRACK(0);
    MUTETRACK(1);
    MUTETRACK(2);
    MUTETRACK(3);
    MUTETRACK(4);
    MUTETRACK(5);
    MUTETRACK(6);
    MUTETRACK(7);
    MUTETRACK(8);
    MUTETRACK(9);
    MUTETRACK(10);
    MUTETRACK(11);
    MUTETRACK(12);
    MUTETRACK(13);
    MUTETRACK(14);
    MUTETRACK(15);
    MUTETRACK(16);
    MUTETRACK(17);
    MUTETRACK(18);
    
EndInitGMParams_29:
    rts;


.ENDMOD;
