/******************************************************************************
*
*  TrigInit.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  functions called when track is retriggered.  pointers to these functions are
*  placed in the a_Seq2 array.
*
******************************************************************************/

.MODULE                                     modTrigInit_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "song3.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      InitTrack00;
.ENTRY      InitTrack01;
.ENTRY      InitTrack02;
.ENTRY      InitTrack03;
.ENTRY      InitTrack04;
.ENTRY      InitTrack05;
.ENTRY      InitTrack06;
.ENTRY      InitTrack07;
.ENTRY      InitTrack08;
.ENTRY      InitTrack09;
.ENTRY      InitTrack10;
.ENTRY      InitTrack11;
.ENTRY      InitTrack12;
.ENTRY      InitTrack13;
.ENTRY      InitTrack14;
.ENTRY      InitTrack15;
.ENTRY      InitTrack16;
.ENTRY      InitTrack17;
.ENTRY      InitTrack18;
.ENTRY      InitTrack19;
.ENTRY      InitTrack20;
.ENTRY      InitTrack21;
.ENTRY      InitTrack22;
.ENTRY      InitTrack23;
.ENTRY      InitTrack24;
.ENTRY      InitTrack25;
.ENTRY      InitTrack26;
.ENTRY      InitTrack27;
.ENTRY      InitTrack28;
.ENTRY      InitTrack29;
.ENTRY      InitTrack30;
.ENTRY      InitTrack31;

InitTrack00:
    RESET_MEMENV2(0);
    rts;
    
InitTrack01:
    RESET_MEMENV2(1);
    rts;

InitTrack02:
    RESET_MEMENV3(0);
    rts;
    
InitTrack03:
    rts;
    
InitTrack04:
    rts;
    
InitTrack05:
    call FillKS0Buff;
    rts;
    
InitTrack06:
    call FillKS1Buff;
    rts;
    
InitTrack07:
    call FillKS2Buff;
    rts;
    
InitTrack08:
    call FillKS3Buff;
    rts;
    
InitTrack09:
    AR = DM(a_WTGen2 + ((3*WTGEN2_VARS)+WTGEN2_FREQ));
    AY0 = 65;
    NONE = AR - AY0;
    if EQ jump Freq41;

Freq65:    
    DM(a_WTGen2 + ((3*WTGEN2_VARS)+WTGEN2_FREQ)) = AY0;
    rts;
    
Freq41:
    AR = 41;
    DM(a_WTGen2 + ((3*WTGEN2_VARS)+WTGEN2_FREQ)) = AR;
    rts;
        
InitTrack10:
    RESET_MEMENV3(1);
    RESET_MEMENV3(2);
    
    AR = DM(I6, M7);
    MY0 = 50;
    MR = AR * MY0 (UU);
    
    AY0 = 70;
    AR = MR1 - AY0;
    if LE jump KeepLeadFreq0;
    AY0 = 20;
    AR = AR - AY0;
    if LE jump IncLeadFreq0;
    jump DecLeadFreq0;

DecLeadFreq0:
    AR = DM(p_LeadNotes0);
    AR = pass AR;
    if EQ jump KeepLeadFreq0;
    AR = AR - 1;
    DM(p_LeadNotes0) = AR;
    jump KeepLeadFreq0;
    
IncLeadFreq0:
    AR = DM(p_LeadNotes0);
    AR = AR + 1;
    AY0 = %a_LeadNotes;
    NONE = AR - AY0;
    if EQ AR = pass 0;
    DM(p_LeadNotes0) = AR;
    jump KeepLeadFreq0;
    
KeepLeadFreq0:
    AR = DM(p_LeadNotes0);
    AY0 = ^a_LeadNotes;
    AR = AR + AY0;
    I3 = AR;
    AR = DM(I3, M0);
    M2 = AR;
    I3 = ^a_MIDIFreq;
    modify(I3, M2);
    AR = DM(I3, M0);
    DM(a_WTGen2 + ((4*WTGEN2_VARS)+WTGEN2_FREQ)) = AR;
    
    rts;
    
InitTrack11:
    AR = DM(I6, M7);
    MY0 = 50;
    MR = AR * MY0 (UU);
    
    AY0 = 70;
    AR = MR1 - AY0;
    if LE jump KeepLeadFreq1;
    AY0 = 20;
    AR = AR - AY0;
    if LE jump IncLeadFreq1;
    jump DecLeadFreq1;

DecLeadFreq1:
    AR = DM(p_LeadNotes1);
    AR = pass AR;
    if EQ jump KeepLeadFreq1;
    AR = AR - 1;
    DM(p_LeadNotes1) = AR;
    jump KeepLeadFreq1;
    
IncLeadFreq1:
    AR = DM(p_LeadNotes1);
    AR = AR + 1;
    AY0 = %a_LeadNotes;
    NONE = AR - AY0;
    if EQ AR = pass 0;
    DM(p_LeadNotes1) = AR;
    jump KeepLeadFreq1;
    
KeepLeadFreq1:
    AR = DM(p_LeadNotes1);
    AY0 = ^a_LeadNotes;
    AR = AR + AY0;
    I3 = AR;
    AR = DM(I3, M0);
    M2 = AR;
    I3 = ^a_MIDIFreq;
    modify(I3, M2);
    AR = DM(I3, M0);
    DM(a_WTGen2 + ((5*WTGEN2_VARS)+WTGEN2_FREQ)) = AR;
    rts;
    
InitTrack12:
    toggle FL1;
    rts;
    
InitTrack13:
    AR = DM(I6, M7);
    AY0 = 0x0003;
    AR = AR and AY0;
    M2 = AR;
    I2 = ^a_PadNotes;
    modify(I2, M2);
    
    AR = DM(I2, M0);
    M2 = AR;
    I2 = ^a_MIDIFreq;
    modify(I2, M2);
    AR = DM(I2, M0);
    
    DM(a_LFO3+(6*LFO3_VARS)+LFO3_BASE) = AR;
    SR = ashift AR by 1 (LO);
    DM(a_LFO3+(7*LFO3_VARS)+LFO3_BASE) = SR0;
    
    rts;
    
InitTrack14:
    rts;
    
InitTrack15:
    rts;
    
InitTrack16:
    rts;
    
InitTrack17:
    rts;
    
InitTrack18:
    rts;
    
InitTrack19:
    rts;
    
InitTrack20:
    rts;
    
InitTrack21:
    rts;
    
InitTrack22:
    rts;
    
InitTrack23:
    rts;
    
InitTrack24:
    rts;
    
InitTrack25:
    rts;
    
InitTrack26:
    rts;
    
InitTrack27:
    rts;
    
InitTrack28:
    rts;
    
InitTrack29:
    rts;
    
InitTrack30:
    rts;
    
InitTrack31:
    rts;
    
.ENDMOD;
