/******************************************************************************
*
*  SongCTRL_29.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
*  function for modifying parameters on a measure by measure basis.  execution
*  rate determined by v_TicsPerMeasure (set in GenFXIni.dsp by macros).
*
******************************************************************************/

.MODULE                                     modSongCTRL_00;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "t29.h"

/*
 *  external variables and functions
 */

/*
 *  entry points
 */

.ENTRY      SongCTRL_29;
.ENTRY      Measure_JT;
.ENTRY      EndMeasure_JT;

SongCTRL_29:
    AR = DM(v_TicCNTR);
    AR = AR + 1;
    DM(v_TicCNTR) = AR;
    AY0 = DM(v_TicsPerMeasure);
    AR = AR - AY0;
    if LT rts;
    
    DM(v_TicCNTR) = M0;

/*
 *  note!  this initialization used to be in InitFunc.dsp.  however, to make
 *  this function work with multiple tracks in a single executable, Measure_JT
 *  and EndMeasure_JT would need to be abstracted and inited in SongPtrs.dsp.
 *  to try and simplify and reduce the number of initializations that occur in
 *  that function, these variables were made local and it is continually
 *  re-inited here.  note that this code runs in the krate loop so performance
 *  is not a concern.
 */

SetMeasuresPerSong:
    AX0 = ^EndMeasure_JT;
    AY0 = ^Measure_JT;
    AR = AX0 - AY0;
    DM(v_MeasuresPerSong) = AR;
    
    I5 = ^Measure_JT;
    M5 = DM(v_CurrMeasure);
    modify(I5, M5);
    jump (I5);
    
/*
 *  insert JT of operations to perform at the start of every new measure
 */
    
Measure_JT:
    jump StartKS5_6;
    jump Measure0;

    /* 1-8 */
    jump StartBDAndSnares;
    jump Measure2;
    jump Measure3;
    jump Measure4;
    jump Measure5;
    jump Measure6;
    jump IncVolRepeatingKS;
    jump IncVolRepeatingKS;
    
    /* 9-16 */
    jump IncVolRepeatingKS;
    jump IncVolRepeatingKS;
    jump IncVolRepeatingKS;
    jump IncVolRepeatingKS;
    jump IncVolRepeatingKS;
    jump IncVolRepeatingKS;
    jump IncVolLowTriangles;
    jump IncVolLowTriangles;
    
    /* 17-24 */
    jump IncVolLowTriangles;
    jump IncVolLowTriangles;
    jump IncVolLowTriangles;
    jump IncVolLowTriangles;
    jump IncVolLowTriangles;
    jump IncVolLowTriangles;
    jump Measure23;
    jump Measure24;
    
    /* 25-32 */
    jump Measure25;
    jump Measure26;
    jump IncVolOscComb1_2;
    jump IncVolOscComb1_2;
    jump IncVolOscComb1_2;
    jump IncVolOscComb1_2;
    jump IncVolOscComb1_2;
    jump IncVolOscComb1_2;
    
    /* 33-40 */
    jump IncVolOscComb1_2;
    jump IncVolOscComb1_2;
    jump IncVolRotSynth1_2;
    jump IncVolRotSynth1_2;
    jump IncVolRotSynth1_2;
    jump IncVolRotSynth1_2;
    jump IncVolRotSynth1_2;
    jump IncVolRotSynth1_2;
    
    /* 41-48 */
    jump IncVolRotSynth1_2;
    jump IncVolRotSynth1_2;
    jump AddBDKSIncVolRotSynth3_4;
    jump AddBDKSIncVolRotSynth3_4;
    jump AddBDKSIncVolRotSynth3_4;
    jump AddBDKSIncVolRotSynth3_4;
    jump AddBDKSIncVolRotSynth3_4;
    jump AddBDKSIncVolRotSynth3_4;
    
    /* 49-56 */
    jump AddBDKSIncVolRotSynth3_4;
    jump AddBDKSIncVolRotSynth3_4;
    jump IncVolOscComb3PanRots1_4;
    jump IncVolOscComb3PanRots1_4;
    jump IncVolOscComb3PanRots1_4;
    jump IncVolOscComb3PanRots1_4;
    jump IncVolOscComb3PanRots1_4;
    jump IncVolOscComb3PanRots1_4;
    
    /* 57-64 */
    jump IncVolOscComb3PanRots1_4;
    jump IncVolOscComb3PanRots1_4;
    jump IncVolRotSynth5_6;
    jump IncVolRotSynth5_6;
    jump IncVolRotSynth5_6;
    jump IncVolRotSynth5_6;
    jump IncVolRotSynth5_6;
    jump IncVolRotSynth5_6;
    
    /* 65-72 */
    jump IncVolRotSynth5_6;
    jump IncVolRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    
    jump IncVolOscComb3PanRotSynth5_6;
    jump IncVolOscComb3PanRotSynth5_6;
    jump ModRotSynthFreqLFO;
    jump Measure84;
    jump Measure85;    
    jump Measure86;
    jump Measure87;
    jump Measure88;
    
    jump Measure89;
    jump Measure90;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    jump ModKS1;
    
    jump RemoveTriKS3_4BDAddKS;
    jump Measure114;
    jump Measure115;
    jump Measure116;
    jump AddNewBDHits;
    jump Measure118;
    jump Measure119;
    jump Measure120;
    
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    jump MuteAndFadeOut;
    
    jump Measure137;
    jump Measure138;
    jump Measure139;
    jump Measure140;
    jump Measure141;
    jump Measure142;
    jump Measure143;    
    jump Measure144;
    
    jump SetNewKS2Pattern;
    jump FadeRotSynths;
    jump FadeRotSynths;
    jump FadeRotSynths;
    jump FadeRotSynths;
    jump FadeRotSynths;
    jump FadeRotSynths;
    jump FadeRotSynths;
    
    jump MuteEverything;
  
EndMeasure_JT:

/*
 *  insert all multimeasure operations - for parameters that should be modified
 *  over multiple measures
 */

MultiMeasureCheck:

EndSongCheck:
    AR = DM(v_CurrMeasure);
    AR = AR + 1;
    DM(v_CurrMeasure) = AR;
    AY0 = DM(v_MeasuresPerSong);
    AR = AR - AY0;
    if LT rts;

/*
 *  SongCTRL list is complete.  jumping to EndSong will start the next song
 *  in a multisong environment.  resetting CurrMeasure starts the Measure_JT
 *  loop over again, causing the same song to play indefinitely
 */
    
    AR = DM(v_CurrMeasure);
    AR = AR - 1;
    DM(v_CurrMeasure) = AR;
    rts;
    
    !DM(v_CurrMeasure) = M0;
    !rts;

MultiMeasureMod:
    AR = DM(v_CurrMeasure);   
    AY0 = SR0;       
    NONE = AR - AY0;         
    if LT jump EndMMM;
    AY0 = SR1;
    NONE = AR - AY0;
    if GT jump EndMMM;
    call (I5);
EndMMM:
    rts;

StartKS5_6:
    UNMUTETRACK(17);
    UNMUTETRACK(18);
    jump MultiMeasureCheck;

StartBDAndSnares:
    UNMUTETRACK(4);
    UNMUTETRACK(5);
    UNMUTETRACK(6);
    UNMUTETRACK(7);
    jump MultiMeasureCheck;

IncVolRepeatingKS:
    AR = DM(a_LMixScalars+T_KS3);
    AY0 = 0x1000;
    AR = AR + AY0;
    DM(a_LMixScalars+T_KS3) = AR;
    DM(a_RMixScalars+T_KS3) = AR;
    DM(a_LMixScalars+T_KS4) = AR;
    DM(a_RMixScalars+T_KS4) = AR;
    jump MultiMeasureCheck;

IncVolLowTriangles:
    AR = DM(a_LMixScalars+T_TRI1);
    AY0 = 0x1000;
    AR = AR + AY0;
    DM(a_LMixScalars+T_TRI1) = AR;
    DM(a_RMixScalars+T_TRI1) = AR;
    DM(a_LMixScalars+T_TRI2) = AR;
    DM(a_RMixScalars+T_TRI2) = AR;
    jump MultiMeasureCheck;

IncVolOscComb1_2:
    AR = DM(a_LMixScalars+T_OSCCOMB1);
    AY0 = 0x1000;
    AR = AR + AY0;
    DM(a_LMixScalars+T_OSCCOMB1) = AR;
    DM(a_RMixScalars+T_OSCCOMB1) = AR;
    DM(a_LMixScalars+T_OSCCOMB2) = AR;
    DM(a_RMixScalars+T_OSCCOMB2) = AR;
    jump MultiMeasureCheck;
    
IncVolRotSynth1_2:
    AR = DM(a_LMixScalars+T_ROT1);
    AY0 = 0x1000;
    AR = AR + AY0;
    DM(a_LMixScalars+T_ROT1) = AR;
    DM(a_RMixScalars+T_ROT1) = AR;
    DM(a_LMixScalars+T_ROT2) = AR;
    DM(a_RMixScalars+T_ROT2) = AR;
    jump MultiMeasureCheck;

AddBDKSIncVolRotSynth3_4:

/* SETTRACK(NOCLEAR, 0, 4,  --a----- --a-----  ------b- ------b- --a----- --a----- ------b- ------b-,
            NOCLEAR, 0, 7,  ------c- ------c-  -------- ------c-,
            a, 50, 0x1800,
            b, 25, 0x1800,
            c, 100, 0x1400,
            END); */

    AR = DM(a_LMixScalars+T_ROT3);
    AY0 = 0x1000;
    AR = AR + AY0;
    DM(a_LMixScalars+T_ROT3) = AR;
    DM(a_RMixScalars+T_ROT3) = AR;
    DM(a_LMixScalars+T_ROT4) = AR;
    DM(a_RMixScalars+T_ROT4) = AR;
    jump MultiMeasureCheck;

IncVolOscComb3PanRots1_4:
    AR = 100;
    DM(v_ProbModOC2_29) = AR;
    
    AR = 68;
    DM(a_Seq2+1+(T_KS5*SEQ2_VARS)+SEQ2_SEQLEN) = AR;
    DM(a_Seq2+1+(T_KS6*SEQ2_VARS)+SEQ2_SEQLEN) = AR;

    AR = DM(a_LMixScalars+T_OSCCOMB3);
    AY0 = 0x0c00;
    AR = AR + AY0;
    DM(a_LMixScalars+T_OSCCOMB3) = AR;
    DM(a_RMixScalars+T_OSCCOMB3) = AR;
    
    AR = DM(a_ADSRPanEnv + ((6*ADSRPANENV_VARS)+ADSRPANENV_PAN));
    AR = AR + 0x200;
    DM(a_ADSRPanEnv + ((6*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;
    AR = DM(a_ADSRPanEnv + ((7*ADSRPANENV_VARS)+ADSRPANENV_PAN));
    AR = AR - 0x200;
    DM(a_ADSRPanEnv + ((7*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;
    AR = DM(a_ADSRPanEnv + ((9*ADSRPANENV_VARS)+ADSRPANENV_PAN));
    AR = AR + 0x200;
    DM(a_ADSRPanEnv + ((9*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;
    AR = DM(a_ADSRPanEnv + ((10*ADSRPANENV_VARS)+ADSRPANENV_PAN));
    AR = AR - 0x200;
    DM(a_ADSRPanEnv + ((10*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;
    
    jump MultiMeasureCheck;

IncVolRotSynth5_6:
    AR = DM(a_LMixScalars+T_ROT5);
    AY0 = 0x1000;
    AR = AR + AY0;
    DM(a_LMixScalars+T_ROT5) = AR;
    DM(a_RMixScalars+T_ROT5) = AR;
    DM(a_LMixScalars+T_ROT6) = AR;
    DM(a_RMixScalars+T_ROT6) = AR;
    
    AR = DM(a_LFO3+(0*LFO3_VARS)+LFO3_BASE);
    AR = AR + 1;
    DM(a_LFO3+(0*LFO3_VARS)+LFO3_BASE) = AR;
    AR = DM(a_LFO3+(1*LFO3_VARS)+LFO3_BASE);
    AR = AR + 1;
    DM(a_LFO3+(1*LFO3_VARS)+LFO3_BASE) = AR;
            
    jump MultiMeasureCheck;

IncVolOscComb3PanRotSynth5_6:
    AR = DM(a_LMixScalars+T_OSCCOMB3);
    AY0 = 0x0200;
    AR = AR + AY0;
    DM(a_LMixScalars+T_OSCCOMB3) = AR;
    DM(a_RMixScalars+T_OSCCOMB3) = AR;
    
    AR = DM(a_ADSRPanEnv + ((11*ADSRPANENV_VARS)+ADSRPANENV_PAN));
    AR = AR + 0x100;
    DM(a_ADSRPanEnv + ((11*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;
    AR = DM(a_ADSRPanEnv + ((12*ADSRPANENV_VARS)+ADSRPANENV_PAN));
    AR = AR - 0x100;
    DM(a_ADSRPanEnv + ((12*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;
    jump MultiMeasureCheck;
    

ModRotSynthFreqLFO:
    AR = 66;
    DM(a_Seq2+1+(T_OSCCOMB3*SEQ2_VARS)+SEQ2_SEQLEN) = AR;
    
    AR = 45;
    DM(a_LFO3+(6*LFO3_VARS)+LFO3_BASE) = AR;
    DM(a_LFO3+(7*LFO3_VARS)+LFO3_BASE) = AR;
    AR = 15;
    DM(a_LFO3+(6*LFO3_VARS)+LFO3_MOD) = AR;
    DM(a_LFO3+(7*LFO3_VARS)+LFO3_MOD) = AR;
    AR = 6;
    DM(a_LFO3+(6*LFO3_VARS)+LFO3_HOLDPER) = AR;
    DM(a_LFO3+(7*LFO3_VARS)+LFO3_HOLDPER) = AR;
    jump MultiMeasureCheck;

ModKS1:

    AR = DM(a_LFO3+(0*LFO3_VARS)+LFO3_BASE);
    AR = AR + 1;
    DM(a_LFO3+(0*LFO3_VARS)+LFO3_BASE) = AR;
    AR = DM(a_LFO3+(1*LFO3_VARS)+LFO3_BASE);
    AR = AR + 1;
    DM(a_LFO3+(1*LFO3_VARS)+LFO3_BASE) = AR;

    AR = DM(a_KSGen+(0*KSGEN_VARS)+KSGEN_FREQ);
    AR = AR - 2;
    AY0 = 0x10;
    NONE = AR - AY0;
    if LE AR = pass AY0;
    DM(a_KSGen+(0*KSGEN_VARS)+KSGEN_FREQ) = AR;

    AR = DM(a_KSGen+(0*KSGEN_VARS)+KSGEN_AVEFAC);
    AY0 = 0x0060;
    AR = AR + AY0;
    DM(a_KSGen+(0*KSGEN_VARS)+KSGEN_AVEFAC) = AR;
    
    AR = DM(a_KSGen+(1*KSGEN_VARS)+KSGEN_FREQ);
    AR = AR + 4;
    AY0 = 0xff;
    NONE = AR - AY0;
    if GT AR = pass AY0;
    DM(a_KSGen+(1*KSGEN_VARS)+KSGEN_FREQ) = AR;

    AR = DM(a_KSGen+(1*KSGEN_VARS)+KSGEN_AVEFAC);
    AY0 = 0x0060;
    AR = AR + AY0;
    DM(a_KSGen+(1*KSGEN_VARS)+KSGEN_AVEFAC) = AR;
    jump MultiMeasureCheck;
    
RemoveTriKS3_4BDAddKS:
    MUTETRACK(T_TRI1);
    MUTETRACK(T_TRI2);
    MUTETRACK(T_KS3);
    MUTETRACK(T_KS4);
    MUTETRACK(T_BD1);
    MUTETRACK(T_BD2);
    
    AR = 300;
    DM(a_MemEnv3+(2*ME3_VARS)+ME3_EA) = AR;
    AR = 301;
    DM(a_MemEnv3+(3*ME3_VARS)+ME3_EA) = AR;
    
    RESET_MEMENV3(2);
    RESET_MEMENV3(3);
    
/* SETTRACK(NOCLEAR, 0, 5,  --a-b-bb ------cc  -------- ----c---,
            NOCLEAR, 0, 7,  -a-a---- --c-c-c-  --b----- --a-----,
            a, 100, 0x1800,
            b, 100, 0x2400,
            c, 100, 0x1400,
            END); */

    jump MultiMeasureCheck;

AddNewBDHits:
    SETTRACKVOL_LR(T_BD1, 0x7fff);
    SETTRACKVOL_LR(T_BD2, 0x7fff);

    I2 = ^a_VolTrack04;
    AR = 0x3800;
    CNTR = 64;
    do A1 until CE;
      DM(I2, M1) = AR;
A1:   AR = AR - 1;
      
    I2 = ^a_VolTrack06;
    AR = 0x2800;
    CNTR = 64;
    do A2 until CE;
      DM(I2, M1) = AR;
A2:   AR = AR - 1;

    I2 = ^a_TrigTrack04;
    M2 = 16;
    AY0 = 100;
    CNTR = 4;
    do A3 until CE;
A3:   DM(I2, M2) = AY0;

    I2 = ^a_TrigTrack06+8;
    M2 = 16;
    AY0 = 100;
    CNTR = 4;
    do A4 until CE;
A4:   DM(I2, M2) = AY0;

    jump MultiMeasureCheck;

MuteAndFadeOut:
    SETTRACKVOL_LR(T_OSCCOMB1, 0x0000);
    SETTRACKVOL_LR(T_OSCCOMB2, 0x0000);
    SETTRACKVOL_LR(T_KS3, 0x0000);
    SETTRACKVOL_LR(T_KS4, 0x0000);
    SETTRACKVOL_LR(T_BD1, 0x0000);
    SETTRACKVOL_LR(T_BD2, 0x0000);

/* SETTRACK(CLEAR, 0, 7,  a-c-b-c- a-c-b-c-  a-c-b-c- a-c-b-c-,
            a, 100, 0x2000,
            b, 100, 0x1800,
            c, 100, 0x1000,
            END); */
    
    AR = DM(a_LMixScalars+T_KS1);
    AY0 = 0x0800;
    AR = AR - AY0;
    DM(a_LMixScalars+T_KS1) = AR;
    DM(a_RMixScalars+T_KS1) = AR;
    DM(a_LMixScalars+T_OSCCOMB3) = AR;
    DM(a_RMixScalars+T_OSCCOMB3) = AR;
    
    
    AR = DM(a_LMixScalars+T_KS2);
    AY0 = 0x0400;
    AR = AR - AY0;
    DM(a_LMixScalars+T_KS2) = AR;
    DM(a_RMixScalars+T_KS2) = AR;
    
    jump MultiMeasureCheck;

SetNewKS2Pattern:

/* SETTRACK(CLEAR, 0, 7,  adcdbdcd adcdbdcd  adcdbdcd adcdbdcd,
            a, 100, 0x2000,
            b, 100, 0x1800,
            c, 100, 0x1000,
            d, 50, 0x0800,
            END); */
            
    AR = DM(a_LMixScalars+T_ROT1);
    AY0 = 0x1000;
    AR = AR - AY0;
    DM(a_LMixScalars+T_ROT1) = AR;
    DM(a_RMixScalars+T_ROT1) = AR;
    DM(a_LMixScalars+T_ROT2) = AR;
    DM(a_RMixScalars+T_ROT2) = AR;
    DM(a_LMixScalars+T_ROT3) = AR;
    DM(a_RMixScalars+T_ROT3) = AR;
    DM(a_LMixScalars+T_ROT4) = AR;
    DM(a_RMixScalars+T_ROT4) = AR;
    DM(a_LMixScalars+T_ROT5) = AR;
    DM(a_RMixScalars+T_ROT5) = AR;
    DM(a_LMixScalars+T_ROT6) = AR;
    DM(a_RMixScalars+T_ROT6) = AR;
    !DM(a_LMixScalars+T_KS2) = AR;
    !DM(a_RMixScalars+T_KS2) = AR;
    
    jump MultiMeasureCheck;

FadeRotSynths:
    AR = DM(a_LMixScalars+T_ROT1);
    AY0 = 0x1000;
    AR = AR - AY0;
    if LE AR = pass 0;
    DM(a_LMixScalars+T_ROT1) = AR;
    DM(a_RMixScalars+T_ROT1) = AR;
    DM(a_LMixScalars+T_ROT2) = AR;
    DM(a_RMixScalars+T_ROT2) = AR;
    DM(a_LMixScalars+T_ROT3) = AR;
    DM(a_RMixScalars+T_ROT3) = AR;
    DM(a_LMixScalars+T_ROT4) = AR;
    DM(a_RMixScalars+T_ROT4) = AR;
    DM(a_LMixScalars+T_ROT5) = AR;
    DM(a_RMixScalars+T_ROT5) = AR;
    DM(a_LMixScalars+T_ROT6) = AR;
    DM(a_RMixScalars+T_ROT6) = AR;
    DM(a_RMixScalars+T_KS5) = AR;
    DM(a_LMixScalars+T_KS5) = AR;
    DM(a_RMixScalars+T_KS6) = AR;
    DM(a_LMixScalars+T_KS6) = AR;
    
    AR = DM(a_LMixScalars+T_KS2);
    AY0 = 0x0800;
    AR = AR - AY0;
    if LE AR = pass 0;    
    DM(a_LMixScalars+T_KS2) = AR;
    DM(a_RMixScalars+T_KS2) = AR;
    
    jump MultiMeasureCheck;    

MuteEverything:
    MUTETRACK(0);
    MUTETRACK(1);
    MUTETRACK(2);
    MUTETRACK(3);
    MUTETRACK(4);
    MUTETRACK(5);
    MUTETRACK(6);
    MUTETRACK(7);
    MUTETRACK(8);
    MUTETRACK(9);
    MUTETRACK(10);
    MUTETRACK(11);
    MUTETRACK(12);
    MUTETRACK(13);
    MUTETRACK(14);
    MUTETRACK(15);
    MUTETRACK(16);
    jump MultiMeasureCheck;        

Measure0:
Measure2:
Measure3:
Measure4:
Measure5:
Measure6:
Measure23:
Measure24:
Measure25:
Measure26:
Measure84:
Measure85:
Measure86:
Measure87:
Measure88:
Measure89:
Measure90:
Measure114:
Measure115:
Measure116:
Measure118:
Measure119:
Measure120:
Measure137:
Measure138:
Measure139:
Measure140:
Measure141:
Measure142:
Measure143:
Measure144:
Measure145:
Measure146:
Measure147:
Measure148:
Measure149:
Measure150:
Measure151:
    jump MultiMeasureCheck;

.ENDMOD;
