/******************************************************************************
*
*  TrigInit.dsp
*  
*  initialization routines when a new sample is triggered
*
*  note that these functions are jumped to from Seq and therefore some state
*  is assumed across calls!  in particular, don't corrupt I3!
*
******************************************************************************/

.MODULE                                     modTrigInit_29;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "t29.h"

/*
 *  external variables and functions
 */


/*
 *  entry points
 */

.ENTRY      InitBD1_29;
.ENTRY      InitBD2_29;
.ENTRY      InitRot1_29;
.ENTRY      InitRot2_29;
.ENTRY      InitRot3_29;
.ENTRY      InitRot4_29;
.ENTRY      InitRot5_29;
.ENTRY      InitRot6_29;
.ENTRY      InitOC4_29;
.ENTRY      InitKS1_29;
.ENTRY      InitKS2_29;
.ENTRY      InitKS5_29;
.ENTRY      InitKS6_29;

/*----------------------------------------------------------------------------*/

InitBD1_29:
    RESET_PHASE_WTGEN(0);
    RESET_MEMENV3(0);

    AR = DM(I6, M7);
    AY0 = 0x0003;
    AR = AR and AY0;
    I5 = ^InitBD1_29JT;
    M5 = AR;
    modify(I5, M5);
    jump (I5);

InitBD1_29JT:
    jump SetBD1_0;
    jump SetBD1_1;
    jump SetBD1_2;
    jump SetBD1_3;
    
SetBD1_0:
    AR = -15;
    DM(a_MemEnv3 +((0*ME3_VARS)+ME3_ED)) = AR;
    rts;
    
SetBD1_1:
    AR = -30;
    DM(a_MemEnv3 +((0*ME3_VARS)+ME3_ED)) = AR;
    rts;
    
SetBD1_2:
    AR = -30;
    DM(a_MemEnv3 +((0*ME3_VARS)+ME3_ED)) = AR;
    rts;
    
SetBD1_3:
    AR = -45;
    DM(a_MemEnv3 +((0*ME3_VARS)+ME3_ED)) = AR;
    rts;

/*----------------------------------------------------------------------------*/

InitBD2_29:
    RESET_PHASE_WTGEN(1);
    RESET_MEMENV3(1);

    AR = DM(I6, M7);
    AY0 = 0x0003;
    AR = AR and AY0;
    I5 = ^InitBD2_29JT;
    M5 = AR;
    modify(I5, M5);
    jump (I5);

InitBD2_29JT:
    jump SetBD2_0;
    jump SetBD2_1;
    jump SetBD2_2;
    jump SetBD2_3;
    
SetBD2_0:
    AR = -20;
    DM(a_MemEnv3 +((1*ME3_VARS)+ME3_ED)) = AR;
    rts;
    
SetBD2_1:
    AR = -40;
    DM(a_MemEnv3 +((1*ME3_VARS)+ME3_ED)) = AR;
    rts;
    
SetBD2_2:
    AR = -40;
    DM(a_MemEnv3 +((1*ME3_VARS)+ME3_ED)) = AR;
    rts;
    
SetBD2_3:
    AR = -60;
    DM(a_MemEnv3 +((1*ME3_VARS)+ME3_ED)) = AR;
    rts;

/*----------------------------------------------------------------------------*/

InitRot1_29:
    NEW_RANDVAL_ROTSYNTHGEN(0);
    rts;

/*----------------------------------------------------------------------------*/

InitRot2_29:
    NEW_RANDVAL_ROTSYNTHGEN(1);
    rts;

/*----------------------------------------------------------------------------*/
    
InitRot3_29:
    NEW_RANDVAL_ROTSYNTHGEN(2);
    rts;

/*----------------------------------------------------------------------------*/

InitRot4_29:
    NEW_RANDVAL_ROTSYNTHGEN(3);
    rts;

/*----------------------------------------------------------------------------*/
    
InitRot5_29:
    NEW_RANDVAL_ROTSYNTHGEN(4);
    rts;

/*----------------------------------------------------------------------------*/
    
InitRot6_29:
    NEW_RANDVAL_ROTSYNTHGEN(5);
    rts;

/*----------------------------------------------------------------------------*/

InitOC4_29:
    AR = DM(I6, M7);
    MY0 = 6;
    MR = AR * MY0 (UU);
    DM(a_OscCombGen+(2*OSCCOMBGEN_VARS)+OSCCOMBGEN_GEN0) = MR1;

    AR = DM(I6, M7);
    MY0 = 6;
    MR = AR * MY0 (UU);
    DM(a_OscCombGen+(2*OSCCOMBGEN_VARS)+OSCCOMBGEN_GEN1) = MR1;

    AR = DM(I6, M7);
    AY0 = 0xfff;
    AF = tstbit 0 of AR;
    if EQ jump LeftPanOC4;

RightPanOC4:
    AR = AR and AY0;
    AR = AR + 0x4000;
    DM(a_ADSRPanEnv + ((8*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;
    rts;

LeftPanOC4:
    AF = AR and AY0;
    AX0 = 0x4000;
    AR = AX0 - AF;
    DM(a_ADSRPanEnv + ((8*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;

    rts;

/*----------------------------------------------------------------------------*/

InitKS1_29:
    call FillKS1Buff;

    AR = DM(I6, M7);
    AY0 = 0x5ff;
    AF = tstbit 0 of AR;
    if EQ jump LeftPanKS1;

RightPanKS1:
    AR = AR and AY0;
    AR = AR + 0x4000;
    DM(a_ExpDecayEnv + ((1*EXPDECAYENV_VARS)+EXPDECAYENV_PAN)) = AR;
    jump NewGenSHFXKS1Val;

LeftPanKS1:
    AF = AR and AY0;
    AX0 = 0x4000;
    AR = AX0 - AF;
    DM(a_ExpDecayEnv + ((1*EXPDECAYENV_VARS)+EXPDECAYENV_PAN)) = AR;

NewGenSHFXKS1Val:    
    AR = DM(I6, M7);
    AY0 = 0x0003;
    AR = AR and AY0;
    I5 = ^GenSHFXKS1_29JT;
    M5 = AR;
    modify(I5, M5);
    jump (I5);

GenSHFXKS1_29JT:
    jump SetGenSHFXKS1_0;
    jump SetGenSHFXKS1_1;
    jump SetGenSHFXKS1_2;
    jump SetGenSHFXKS1_3;
    
SetGenSHFXKS1_0:
    AR = 5;
    jump SetGenSHFXKS1Val;
    
SetGenSHFXKS1_1:
    AR = 6;
    jump SetGenSHFXKS1Val;
    
SetGenSHFXKS1_2:
    AR = 7;
    jump SetGenSHFXKS1Val;
    
SetGenSHFXKS1_3:
    AR = 8;
    jump SetGenSHFXKS1Val;
    
SetGenSHFXKS1Val:
    DM(a_GenSHFX+(0*GENSHFX_VARS)+GENSHFX_HOLDPER) = AR;

    
MoreModKS1:
    AR = DM(a_KSGen+(0*KSGEN_VARS)+KSGEN_ADDSUB);
    AR = tglbit 0 of AR;
    DM(a_KSGen+(0*KSGEN_VARS)+KSGEN_ADDSUB) = AR;

    AR = DM(I6, M7);
    AY0 = DM(v_KSMask1_29);
    AF = AR and AY0;
    AR = tstbit 4 of AR;
    AX0 = DM(a_KSGen+(0*KSGEN_VARS)+KSGEN_AVEFACSIGN);
    if EQ jump AddRand1;

SubRand1:
    AR = AX0 - AF;
    jump WriteKS1;
    
AddRand1:
    AR = AX0 + AF;
WriteKS1:
    DM(a_KSGen+(0*KSGEN_VARS)+KSGEN_AVEFACSIGN) = AR;

    rts;

/*----------------------------------------------------------------------------*/

InitKS2_29:
    call FillKS2Buff;

    AR = DM(I6, M7);
    AY0 = 0x5ff;
    AF = tstbit 0 of AR;
    if EQ jump LeftPanKS2;

RightPanKS2:
    AR = AR and AY0;
    AR = AR + 0x4000;
    DM(a_ExpDecayEnv + ((3*EXPDECAYENV_VARS)+EXPDECAYENV_PAN)) = AR;
    jump NewGenSHFXKS2Val;

LeftPanKS2:
    AF = AR and AY0;
    AX0 = 0x4000;
    AR = AX0 - AF;
    DM(a_ExpDecayEnv + ((3*EXPDECAYENV_VARS)+EXPDECAYENV_PAN)) = AR;

NewGenSHFXKS2Val:    
    AR = DM(I6, M7);
    AY0 = 0x0003;
    AR = AR and AY0;
    I5 = ^GenSHFXKS2_29JT;
    M5 = AR;
    modify(I5, M5);
    jump (I5);

GenSHFXKS2_29JT:
    jump SetGenSHFXKS2_0;
    jump SetGenSHFXKS2_1;
    jump SetGenSHFXKS2_2;
    jump SetGenSHFXKS2_3;
    
SetGenSHFXKS2_0:
    AR = 2;
    jump SetGenSHFXKS2Val;
    
SetGenSHFXKS2_1:
    AR = 3;
    jump SetGenSHFXKS2Val;
    
SetGenSHFXKS2_2:
    AR = 4;
    jump SetGenSHFXKS2Val;
    
SetGenSHFXKS2_3:
    AR = 5;
    jump SetGenSHFXKS2Val;
    
SetGenSHFXKS2Val:
    DM(a_GenSHFX+(1*GENSHFX_VARS)+GENSHFX_HOLDPER) = AR;
    
MoreModKS2:
    AR = DM(I6, M7);
    AY0 = DM(v_KSMask2_29);
    AF = AR and AY0;
    AR = tstbit 4 of AR;
    AX0 = DM(a_KSGen+(1*KSGEN_VARS)+KSGEN_AVEFACSIGN);
    if EQ jump AddRand2;

SubRand2:
    AR = AX0 - AF;
    jump WriteKS2;
    
AddRand2:
    AR = AX0 + AF;
WriteKS2:
    DM(a_KSGen+(1*KSGEN_VARS)+KSGEN_AVEFACSIGN) = AR;

    rts;

InitKS5_29:
    call FillKS5Buff;
    rts;
    
InitKS6_29:
    call FillKS6Buff;
    rts;

.ENDMOD;
