/******************************************************************************
*
*  TrigKS3.dsp
*  
*  generative music trigger for starting KS generator
*
******************************************************************************/

.MODULE                                     modTrigKS3_29;

/*
 *  include files for all functions
 */


#include    ".\comsys\hdr\DSPdefs.h"
#include    ".\gen_fx\hdr\GenFX.h"
#include    "t29.h"

/*
 *  external variables and functions
 */

.EXTERNAL   v_TrigKS3_29;
.EXTERNAL   v_KSPeriod3_29;
.EXTERNAL   a_KSBuff3;
.EXTERNAL   v_KS3Count_29;
.EXTERNAL   v_KSMask3_29;
.EXTERNAL   a_KSGen;
.EXTERNAL   v_BaseScalarKS3_29;
!.EXTERNAL   a_Scalar;

/*
 *  entry points
 */
 
.ENTRY      TrigKS3_29;

TrigKS3_29:
    AR = DM(v_TrigKS3_29);
    AR = AR + 1;
    DM(v_TrigKS3_29) = AR;
    AY0 = DM(v_KSPeriod3_29);
    AR = AR - AY0;
    if LT rts;

InitKS3:
    DM(v_TrigKS3_29) = M0;

    AR = DM(v_KS3Count_29);
    AR = AR - 1;
    DM(v_KS3Count_29) = AR;
    if LE jump NewKS3Count;
    
    call FillKS3Buff;

    /* pan ks3 */
    AR = DM(I6, M7);
    AY0 = 0x5ff;
    AF = tstbit 0 of AR;
    if EQ jump LeftPanKS3;

RightPanKS3:
    AR = AR and AY0;
    AR = AR + 0x4000;
    DM(a_ADSRPanEnv + ((4*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;
    jump ModKS3Freq;

LeftPanKS3:
    AF = AR and AY0;
    AX0 = 0x4000;
    AR = AX0 - AF;
    DM(a_ADSRPanEnv + ((4*ADSRPANENV_VARS)+ADSRPANENV_PAN)) = AR;

ModKS3Freq:
    AR = DM(a_KSGen+(2*KSGEN_VARS)+KSGEN_FREQ);
    AR = AR - 16;
    DM(a_KSGen+(2*KSGEN_VARS)+KSGEN_FREQ) = AR;
    
    AR = DM(a_ADSRPanEnv+(4*ADSRPANENV_VARS)+ADSRPANENV_SCALAR);
    AY0 = 0x0040;
    AR = AR + AY0;
    DM(a_ADSRPanEnv+(4*ADSRPANENV_VARS)+ADSRPANENV_SCALAR) = AR;
    
    AR = DM(a_GenSHFX+(2*GENSHFX_VARS)+GENSHFX_HOLDPER);
    AR = AR + 1;
    DM(a_GenSHFX+(2*GENSHFX_VARS)+GENSHFX_HOLDPER) = AR;

NoScaleInc:
    AR = DM(I6, M7);
    AR = AR and 1;
    DM(a_KSGen+(2*KSGEN_VARS)+KSGEN_ADDSUB) = AR;

    AR = DM(I6, M7);
    AY0 = DM(v_KSMask3_29);
    AF = AR and AY0;
    AR = tstbit 4 of AR;
    AX0 = DM(a_KSGen+(2*KSGEN_VARS)+KSGEN_AVEFACSIGN);
    if EQ jump AddRand3;
    
SubRand3:
    AR = AX0 - AF;
    jump WriteKS3;
    
AddRand3:
    AR = AX0 + AF;
WriteKS3:
    DM(a_KSGen+(2*KSGEN_VARS)+KSGEN_AVEFACSIGN) = AR;
    
    rts;

NewKS3Count:
    AR = 7;
    DM(a_GenSHFX+(2*GENSHFX_VARS)+GENSHFX_HOLDPER) = AR;
    
    AR = DM(v_BaseScalarKS3_29);
    DM(a_ADSRPanEnv+(4*ADSRPANENV_VARS)+ADSRPANENV_SCALAR) = AR;

    AR = DM(I6, M7);
    MY0 = 8;
    MR = AR * MY0 (SS);
    DM(v_KS3Count_29) = MR1;
    
    AR = 0x1ff;
    DM(a_KSGen+(2*KSGEN_VARS)+KSGEN_FREQ) = AR;
    rts;

.ENDMOD;
