#!/usr/bin/perl

$cmd = $ARGV[0];

# fb/fb_dl commands
$fb_tooltype = $ARGV[1];
$fb_target = $ARGV[2];
$fb_proj = $ARGV[3];

# dl command
$dl_target = $ARGV[1];
$dl_proj = $ARGV[2];

# clone command
$clone_oldproj = $ARGV[1];
$clone_newproj = $ARGV[2];

# clean command
$clean_tooltype = $ARGV[1];
$clean_proj = $ARGV[2];

# tc command
$tc_param = $ARGV[1];
$tc_inputval = $ARGV[2];

#fc command
$fc_param = $ARGV[1];
$fc_valsign = $ARGV[2];
$fc_inputval = $ARGV[3];

if($cmd =~ /fb_dl/)
{
    &fb_dl;
    exit;
}

if($cmd =~ /fb/)
{
    &fb;
    exit;
}

if($cmd =~ /dl/)
{
    &dl;
    exit;
}

if($cmd =~ /clean/)
{
    &clean;
    exit;
}

if($cmd =~ /clone/)
{
    &clone;
    exit;
}

if($cmd =~ /tc/)
{
    &tc;
    exit;
}

if($cmd =~ /fc/)
{
    &fc;
    exit;
}

    # if all the tests fall through, display help
    &help;
    exit;

################################################################################

sub fb
{
    if(!$fb_tooltype)
    {
        print "\n";
        &fbhelp;
        exit;
    }

    $objext = ".obj";
    $new_target = $fb_target;
    if($fb_tooltype =~ /vdsp/)
    {
        $new_target = 'v'.$fb_target;
        $objext = ".doj";
    }
    elsif($fb_tooltype !~ /legacy/)
    {
        print "\n";
        &fbhelp;
        exit;
    }

    if($fb_target =~ /chic/)
    {
        $exesuffix = '_chic';
    }
    elsif($fb_target =~ /ez81/)
    {
        $exesuffix = '_ez81';
    }
    $toolout = $fb_proj.$exesuffix.'.exe';
    $reftoolout = $toolout.'.ref';
    
    #print "rename $toolout $reftoolout\n";
    #system "rename $toolout $reftoolout";
    system ".\\tools\\build_subbat $new_target $fb_proj";
    
    @files = glob ".\\$fb_proj\\*.dsp";
    $projpath = '.\\'.$fb_proj.'\\';
    $sniplen = length($projpath);
    foreach $fileline (@files)
    {
        $snipfile[$i++] = substr($fileline, $sniplen);
    }        

    open(OBJWRITE, ">projobj.bat");
    print OBJWRITE "echo off\n";
    foreach $snipfile (@snipfile)
    {
        $snipfile =~ s/.dsp/$objext/;
        print OBJWRITE "copy $snipfile .\\$fb_proj\\obj\\$snipfile\n";
        print OBJWRITE "del $snipfile\n";
    }
    print OBJWRITE "echo on\n";
    close(OBJWRITE);
    system "projobj.bat";
    
}

################################################################################

sub fb_dl
{
    if(!$fb_tooltype)
    {
        print "\n";
        &fb_dlhelp;
        exit;
    }
    
    $objext = ".obj";
    $new_target = $fb_target;
    if($fb_tooltype =~ /vdsp/)
    {
        $new_target = 'v'.$fb_target;
        $objext = ".doj";
    }
    elsif($fb_tooltype !~ /legacy/)
    {
        print "\n";
        &fb_dlhelp;
        exit;
    }
    # build project
    system ".\\tools\\build_subbat $new_target $fb_proj";

    # move project-related object files
    @files = glob ".\\$fb_proj\\*.dsp";
    $projpath = '.\\'.$fb_proj.'\\';
    $sniplen = length($projpath);
    foreach $fileline (@files)
    {
        $snipfile[$i++] = substr($fileline, $sniplen);
    }        

    open(OBJWRITE, ">projobj.bat");
    print OBJWRITE "echo off\n";
    foreach $snipfile (@snipfile)
    {
        $snipfile =~ s/.dsp/$objext/;
        print OBJWRITE "copy $snipfile .\\$fb_proj\\obj\\$snipfile\n";
        print OBJWRITE "del $snipfile\n";
    }
    print OBJWRITE "echo on\n";
    close(OBJWRITE);
    system "projobj.bat";
    
    if($fb_target =~ /chic/)
    {
        $exesuffix = '_chic';
    }
    elsif($fb_target =~ /ez81/)
    {
        $exesuffix = '_ez81';
    }
    $toolout = $fb_proj.$exesuffix.'.exe';
    
    system ".\\tools\\downloader $toolout";
}

################################################################################

sub dl
{
    if(!$dl_target)
    {
        print "\n";
        &dlhelp;
        exit;
    }
    
    if($dl_target =~ /chic/)
    {
        $exesuffix = '_chic';
    }
    elsif($dl_target =~ /ez81/)
    {
        $exesuffix = '_ez81';
    }
    $toolout = "$dl_proj"."$exesuffix".'.exe';
    system ".\\tools\\downloader $toolout";
}

################################################################################

sub clean
{
    if(!$clean_tooltype)
    {
        print "\n";
        &cleanhelp;
        exit;
    }
    
    $cleantype = "clean";
    if($clean_tooltype =~ /vdsp/)
    {
        $cleantype = 'v'.$cleantype;
    }
    elsif($clean_tooltype !~ /legacy/)
    {
        print "\n";
        &cleanhelp;
        exit;
    }
        
    system ".\\tools\\gmake $cleantype PROJNAME=$clean_proj";
}

################################################################################

sub clone
{
    if(!$clone_oldproj)
    {
        print "\n";
        &clonehelp;
        exit;
    }
        
    system ".\\tools\\cloneproj $clone_oldproj $clone_newproj";
    exit;
}

################################################################################

sub tc
{
    if(!$tc_param)
    {
        print "\n";
        &tchelp;
        exit;
    }
    
    if($tc_param !~ /-/)
    {
        $tc_param = '-'.$tc_param;
    }
    system ".\\tools\\timeconv $tc_param $tc_inputval";
}

################################################################################

sub fc
{
    if(!$fc_param)
    {
        print "\n";
        &fchelp;
        exit;
    }
    
    if($fc_param !~ /-/)
    {
        $fc_param = '-'.$fc_param;
    }
    
    if($fc_valsign !~ /-/)
    {
        $fc_valsign = '-'.$fc_valsign;
    }
    
    system ".\\tools\\formatconv $fc_param $fc_valsign $fc_inputval";
}

################################################################################

sub help
{
    &helphdr;
    print "sdk [command] [param1] [param2] ...\n";
    print "\n";
    print "available commands:\n";
    print "\n";
    &fbhelp;
    &fb_dlhelp;
    &dlhelp;
    &cleanhelp;
    &clonehelp;
    &tchelp;
    &fchelp;
}

################################################################################

sub helphdr
{
    print "\n";
    print "SynDevKit 1.40\n";
    print "(c) 2002-2004 Ethan Bordeaux\n";
    print 'syndevkit@dspmusic.org'; print "\n";
    print "\n";
}

################################################################################

sub fbhelp
{
    print "  fb legacy/vdsp [target] [proj]:  force build of project - do not download\n";
    print "\n";
    print "    legacy/vdsp:  legacy for 5.11-7.0 tools, vdsp for visualDSP++\n";
    print "    [target]:     hardware to target with executable.  viable targets\n";
    print "                  are 'ez81' and 'chic'.\n";
    print "    [proj]:       project to build\n";
    print "\n";
    print "  example:  c:\\>sdk fb legacy ez81 ex2\n";
    print "\n";
    print "  --------------------------------------------------------------\n";
    print "\n";
}

################################################################################

sub fb_dlhelp
{
    print "  fb_dl legacy/vdsp [target] [proj]:  force build and download of project\n";
    print "\n";
    print "    legacy/vdsp:  legacy for 5.11-7.0 tools, vdsp for visualDSP++\n";
    print "    [target]:     hardware to target with executable.  viable targets\n";
    print "                  are 'ez81' and 'chic'.\n";
    print "    [proj]:       project to build\n";
    print "\n";
    print "  example:  c:\\>sdk fb_dl vdsp chic ex3\n";
    print "\n";
    print "  --------------------------------------------------------------\n";
    print "\n";
    
}

################################################################################

sub dlhelp
{
    print "  dl [target] [proj]:  download project to target hardware\n";
    print "\n";
    print "    [target]:  hardware to target with executable.  viable targets\n";
    print "               are 'ez81' and 'chic'.\n";
    print "    [proj]:    file to download\n";
    print "\n";
    print "  example:  c:\\>sdk dl ez81 ex3\n";
    print "\n";
    print "  --------------------------------------------------------------\n";
    print "\n";
}

################################################################################

sub cleanhelp
{
    print "  clean legacy/vdsp [proj]:  clean intermediate files from [proj] build\n";
    print "\n";
    print "    legacy/vdsp:  legacy for 5.11-7.0 tools, vdsp for visualDSP++\n";
    print "    [proj]:       project to write intermediate files to\n";
    print "\n";
    print "  example:  c:\\>sdk clean legacy ex0\n";
    print "\n";
    print "  --------------------------------------------------------------\n";
    print "\n";
}

################################################################################

sub clonehelp
{
    print "  clone [oldproj] [newproj]:  make a copy of oldproj called newproj\n";
    print "\n";
    print "    [oldproj]:  original SynDevKit project\n";
    print "    [newproj]:  new SynDevKit project\n";
    print "\n";
    print "  example:  c:\\>sdk clone template newsong\n";
    print "\n";
    print "  --------------------------------------------------------------\n";
    print "\n";
}

################################################################################

sub tchelp
{
    print "  tc k2b/b2k/k2l [inputval]:  timebase converter\n";
    print "\n";
    print "    k2b:         convert input krate to equivalent BPM\n";
    print "    b2k:         convert input BPM to equivalent krate\n";
    print "    k2l:         convert input krate to equivalent LFO frequency\n";
    print "    [inputval]:  input value to be converted\n";
    print "\n";
    print "  example:  c:\\>sdk tc b2k 120\n";
    print "\n";
    print "  --------------------------------------------------------------\n";
    print "\n";
}

################################################################################

sub fchelp
{
    print "  fc f2h/h2f u/s [inputval]:  format converter\n";
    print "\n";
    print "    f2h:         convert input fractional (ie: 0.25) to 16bit hex\n";
    print "    h2f:         convert input 16bit hex (ie: 0x123b) to fractional\n";
    print "    u:           input is an unsigned (0.16) fixed point value\n";
    print "    s:           input is a signed (1.15) fixed point value\n";
    print "    [inputval]:  input value to be converted\n";
    print "\n";
    print "  example:  c:\\>sdk fc f2h u 0.4591\n";
    print "\n";
    print "  --------------------------------------------------------------\n";
    print "\n";
}