/******************************************************************************
*
*  VolEnv.dsp
*
*  (c) 2001, 2002, 2003 ethan bordeaux
*  syndevkit@dspmusic.org
*
******************************************************************************/

.MODULE                                     modVolEnv;

/*
 *  include files
 */

!#include    ".\comsys\hdr\DSPdefs.h"
!#include    ".\gen_fx\hdr\GenFX.h"

.EXTERNAL   USDivideNoRem;
.EXTERNAL   p_VolEnv;

/*
 *  entry points
 */

.ENTRY      VolEnv;

VolEnv:
    I2 = DM(p_VolEnv);
    SI = DM(I2, M1);                        /* get mod address */
    
    I3 = I2;
    AX0 = DM(I3, M1);                       /* intcntr */
    AX1 = DM(I3, M1);                       /* start */
    AY1 = DM(I3, M1);                       /* end */
    AY0 = DM(I3, M1);                       /* time */
    NONE = AX0 - AY0;
    if GT jump EnvEndReached;

    /* determine if env is up or down */
    NONE = AX1 - AY1;
    if GT jump DecayVolEnv;

AttackVolEnv:    
    AR = DM(I2, M0);                        /* curr tic (intcntr) */
    MY0 = AR;
    AR = AR + 1;
    DM(I2, M1) = AR;
    AX1 = AR;                               /* keep curr tic */
    AY0 = DM(I2, M1);                       /* start attack val */
    SR0 = AY0;                              /* keep attack val */
    AX0 = DM(I2, M1);                       /* end attack val */
    AR = AX0 - AY0;                         /* end-start */
    ena M_MODE;
    MR = AR * MY0 (SS);                     /* (end-start)*currtic (int mult) */
    dis M_MODE;
    AX0 = DM(I2, M1);                       /* tot tic */
    AY1 = MR1;
    AY0 = MR0;
    AF = pass AY1;
    call USDivideNoRem;
    AR = SR0 + AY0;
    I3 = SI;
    DM(I3, M0) = AR;
    AR = I2;
    DM(p_VolEnv) = AR;

    rts;

EnvEndReached:
    DM(p_VolEnv) = I3;
    I2 = SI;
    DM(I2, M0) = AY1;
    rts;        

DecayVolEnv:
    AR = DM(I2, M0);                        /* curr tic */
    MY0 = AR;
    AR = AR + 1;
    DM(I2, M1) = AR;
    !modify(I2, M1);
    AX1 = DM(I2, M1);                       /* get end attack */
    !modify(I2, M1);
    AY0 = DM(I2, M1);                       /* get end decay */
    AR = AX1 - AY0;                         /* EA-ED */
    ena M_MODE;
    MR = AR * MY0 (SS);                     /* (EA-ED)*currtic (int mult) */
    dis M_MODE;
    AX0 = DM(I2, M1);                       /* get tot tic */
    AY1 = MR1;
    AY0 = MR0;
    AF = pass AY1;
    call USDivideNoRem;
    AR = AX1 - AY0;
    I3 = SI;
    DM(I3, M0) = AR;
    AR = I2;
    DM(p_VolEnv) = AR;

    rts;
    
.ENDMOD;
